
iocb	= $340
ciov	= $e456

	.extrn putline .proc (.word ya) .reg	; procedura PUTLINE z biblioteki STDIO

	.public	open, close, read


	.RELOC


* --- VARIABLES

	.var	fname, buf, len	.word
	.var	chn, com	.byte
	
/*
  OPEN

  Command:
          $03 - OPEN

  Example:
          open channel , #command(4 or 8) , #file_name
          open #$10 , #4 , #file_name

          file_name dta c'...',$9b
          channel = $10,$20,$30 ...
*/
open	.proc (.byte chn,com .word fname) .var

	ldx	chn

	mva	#3	iocb+2,x	; CIO command ; $03 - OPEN

	mwa	fname	iocb+4,x	; file name

	mva	com	iocb+$a,x	; $04 - READ ; $08 - WRITE
 
	jmp	pciov

	.endp


/*
  CLOSE

  Command:
          $0C - CLOSE

  Example:
          close channel
          close #$10

          channel = $10,$20,$30 ...
*/
close	.proc (.byte x) .reg

	mva	#$c	iocb+2,x	; CIO command

	jmp	pciov

	.endp


/*
  READ

  Command:
          $05 - GET RECORD
          $07 - GET CHARACTER
          $09 - PUT RECORD
          $0B - PUT CHARACTERS

  Example:
          read channel , #command , #buffer , #length
          read #$10 , command , buffer , length

          channel = $10,$20,$30 ...
*/
read	.proc (.byte chn,com .word buf,len) .var

	ldx	chn

	mva	com	iocb+2,x	; CIO command

	mwa	buf	iocb+4,x	; buffer address

	mwa	len	iocb+8,x	; length

	jmp	pciov

	.endp


/*
  PCIOV
  
  regY = status
*/
pciov	.proc

        jsr	ciov
 
        sty	status+1

        bmi	err
        rts

err
        lda	status+1
        :4	lsr @
        tax

        lda	hex,x
        sta	io_code
 
        lda	status+1
        and	#$0f
        tax

        lda	hex,x
        sta	io_code+1

	putline	#io_error

status  ldy	#0
        rts

io_error	dta 'I/O Error $'
io_code		dta '  ',$9b

hex		dta '0123456789ABCDEF'

	.endp


