
* ---	LOOP
; glowna petla sterujaca wykonywana non-stop

LOOP

* ---	modyfikujemy BUFOR2, wyswietlamy BUFOR3

	WAIT	B3

	mva	#charsBAK	free	; pierwszy wolny znak do wykorzystania przez duchy

	INITBUF	B2

	mva cloc $200			; w komorce $200 liczba ramek reprezentujaca szybkosc silnika


* ---	modyfikujemy BUFOR3, wyswietlamy BUFOR2

	WAIT	B2

	mva	#charsBAK	free	; pierwszy wolny znak do wykorzystania przez duchy

	INITBUF	B3

	mva cloc $200			; w komorce $200 liczba ramek reprezentujaca szybkosc silnika

	jmp loop



* ---	B2SHAPE
; stawianie duchow w BUFOR #2
;
; B2CALC inicjuje adresy SRC, DST na podstawie znakow odczytanych z pamieci obrazu BUFOR #2
; dodatkowo ustawia nowe znaki w miejsce wczesniej odczytanych ktore beda reprezentowac ducha

B2SHAPE	.proc

	SPRTEST			; krotki test, czy aktualny duch bedzie przetwarzany w tej kolejce

	jsr	GETPARAM	; w GETPARAM m.in. rejestr X zostaje zapamietany w OLDX
				; oraz parametry ducha zostaja przepisane to zmiennych POSX, POSY, BANK, TYPE, HEIGHT
*---
	CALC	B2		; wlasciwy fragment kodu modyfikujacy znaki z BUFOR #3	
*---				; na koncu skaczemy do programu obslugi ducha

	jmp	DETECT_UPD	; konczymy skokiem do procedury aktualizacji tablic detekcji COLISx, COLISy

	.endp


* ---	B3SHAPE
; stawianie duchow w BUFOR #3
;
; B3CALC inicjuje adresy SRC, DST na podstawie znakow odczytanych z pamieci obrazu BUFOR #3
; dodatkowo ustawia nowe znaki w miejsce wczesniej odczytanych ktore beda reprezentowac ducha

B3SHAPE	.proc

	SPRTEST			; krotki test, czy aktualny duch bedzie przetwarzany w tej kolejce

	jsr	GETPARAM	; w GETPARAM m.in. rejestr X zostaje zapamietany w OLDX
				; oraz parametry ducha zostaja przepisane to zmiennych POSX, POSY, BANK, TYPE, HEIGHT
*---
	CALC	B3		; wlasciwy fragment kodu modyfikujacy znaki z BUFOR #3		
*---				; na koncu skaczemy do programu obslugi ducha

	jmp	DETECT_UPD	; konczymy skokiem do procedury aktualizacji tablic detekcji COLISx, COLISy

	.endp



* ---	GETPARAM
; wspolna dla B2SHAPE i B3SHAPE procedura odczytujaca i uaktualniajaca parametry ducha
; zwiekszany jest licznik klatek animacji @SPRITE.FRM, maksymalna liczba klatek animacji
; podana jest w tablicy SHAPES -> SHAPES.FRM

GETPARAM
	stx	oldX

	lda	sprites[0].shp,x	; odczytujemy z SHAPES informacje o danych opisujacych ducha

	ift @SHAPE=2
	 asl @
	eli @SHAPE=4
	 asl @
	 asl @
	els
	 ert 'not defined'
	eif

	tay
	mva	shapes[0].bnk,y		bank
	mva	shapes[0].typ,y		type
	mva	shapes[0].hig,y		height

	mva	sprites[0].psx,x	posx
	mva	sprites[0].psy,x	posy

	and #7				; obliczamy ofset przesuniecia w pionie dla SHP i MSK
	eor #7
	add #1
	sta	help			; help = (posy&7)^7+1

	lda	sprites[0].frm,x
	cmp	shapes[0].frm,y		; maksymalna liczba klatek (rejestr Y zawiera indeks do tablicy SHAPES)
	bcc	_skip

	lda	#0			; zerujemy licznik klatek
	sta	sprites[0].frm,x

_skip
	tay				; w rejestrze Y znajduje sie aktualny numer klatki do wyswietlenia

	inc	sprites[0].frm,x	; zwiekszamy licznik klatek

	lda	posx
	and	#3
	asl	@		; a=(posx&3)*2

	clc
	adc	mul8,y		; a=a+y*8
	tay

*---
; inicjalizacja adresow SHP i MSK
;
; odbywa sie przez zaincjowanie rejestrow A, X, Y odpowiednia wartoscia z tablic
; shpAdr12, mskAdr12	dla ducha 12x24
; shpAdr8, mskAdr8	dla ducha 8x24
;
; potem zwiekszamy SHP i MSK co 8 bajtow
;
; MSK wzgledem SHP przesuniete jest zawsze o $2000 bajtow, wykorzystujemy ta wlasciwosc przy optymalizacji kodu

	lda	type		; rodzaj ducha, wartosc =0 to duch 12x24, wartosc <>0 to duch 8x24
	beq	_12x24

_8x24	.local
	sty	tmpY+1
	lda	shpAdr8,y	; duch 8x24
	ldx	shpAdr8+1,y
tmpY	ldy	mskAdr8		; mskAdr8 zaczyna sie od poczatku strony pamieci wiec mozemy zrobic taki trick
	jmp	_skp
	.endl
	
_12x24	.local
	sty	tmpY+1
	lda	shpAdr12,y	; duch 12x24
	ldx	shpAdr12+1,y
tmpY	ldy	mskAdr12	; mskAdr12 zaczyna sie od poczatku strony pamieci wiec mozemy zrobic taki trick
	.endl
_skp

	add	help		; ofset dla SHP i MSK
	bcc	*+4
	inx:iny

	.rept 16
	sta	zp[#].shp
	sta	zp[#].msk
	stx	zp[#].shp+1
	sty	zp[#].msk+1

	ift #<>15
	 add #8
	 bcc	*+4
	 inx:iny
	eif

	.endr

	rts



*---	M A C RO S


* ---	WAIT
; kod odpowiedzialny za synchronizacje obrazu i przelaczanie obrazow

WAIT	.macro
_wait	lda:cmp:req cloc

;	lda cloc
	cmp #min_frames-1
	bcc _wait

	lda	<:1ant
	ldx	>:1ant
	sta	560
	stx	560+1
	sta	$d402
	stx	$d402+1

	mva #0	cloc		; zerujemy licznik ramek

	mva	>:1fnt0	dli0+1
	mva	>:1fnt1	dli1+1
	mva	>:1fnt2	dli2+1
	mva	>:1fnt3	dli3+1

	.endm



* ---	CALC
; na podstawie pozycji poziomej oceniamy czy mozemy optymalizowac ducha 12x24 poprzez wywolanie ducha 8x24
;
; inicjalizujemy adresy wywolujac B2CALC8,B3CALC8 dla ducha 8x24 lub B2CALC,B3CALC dla ducha 12x24
; konczymy modyfikacje wywolujac procedure na stronie zerowej SHAPEZP
;
; ostatnia czynnoscia jest skok do programu obslugi ducha _JMP
;

CALC	.macro

	lda	type
	bne	_8x24


	lda	posx		; optymalizacja dla ducha 12x24 i klatki SHR0 (przepisujemy tylko 12 znakow zamiast 16)
	and	#3
	bne	_12x24

_8x24
	SBANK	:1calc8
	sta	$d301
	jsr	:1calc8

	mva	bank	$d301


; modyfikujemy kod programu na stronie zerowej aby modyfikowal 12 znakow a nie 16
	?b = 12

	mva	#{jmp *}	zp[?b].lda
	mwa	#zp[15].dst+2	zp[?b].lda+1

	ldy #7
	jsr SHAPEZP

; przywracamy poprzedni kod programu

	mva	#{lda *,y}	zp[?b].lda
;	mwa	#$ffff		zp[?b].lda+1

	jmp	_cont

_12x24
	SBANK	:1calc
	sta	$d301
	jsr	:1calc

	mva	bank	$d301

	ldy #7
	jsr SHAPEZP

_cont

	ldx oldX
	mwa sprites[0].prg,x	_jsr+1

_jsr	jsr $ffff		; skok do programu obslugi ducha

	.endm


* ---	SPRTEST
; sprawdzamy wartosc spod adresu SPRITES.NEW
; wartosc <>0 oznacza ze duch zostal dopisany w tej kolejce i dlatego zostanie obsluzony dopiero w nastepnej

SPRTEST	.macro

	lda	sprites[0].new,x	; czy w tej kolejce ten duch moze zostac obsluzony
	beq	_ok

	mva #0	sprites[0].new,x	; ale w nastepnej i tak zostanie obsluzony
	rts
_ok
	.endm



* ---	INITBUF
; zainicjowanie odpowiedniego bufora (B2BUF lub B3BUF) poprzez przepisanie tla z glownego bufora BUFOR #1
; nastepnie sprawdzamy MAX_SPRITES razy czy duch jest aktywny i czy mamy go obsluzyc
;
; dodatkowo oprocz przepisania tla kasowana jest zawartosc buforow kolizji COLISx, COLISy poprzez
; wypelnienie ich wartoscia $FF
;

INITBUF	.macro

	SBANK	:1init		; zaincjowanie bufora B2INIT lub B3INIT		
	sta	$d301
	jsr	:1init

	.rept max_sprites	; maksymalna liczba duchow do wyswietlenia

	ldx #@sprite*#		; x=x+@SPRITES
	lda sprites[0].sts,x
	seq
	jsr :1SHAPE		; skok do procedury obslugi (tworzenia) ducha B2SHAPE lub B3SHAPE

	.endr

	.endm
