;*****************************
;       Yie Ar Kung-Fu
;            by
;    Krzysztof Gra (vega)
;        (c) 2006
;*****************************

 opt b+

 icl 'include\music\mpt_relocator.mac'; makro do relokacji pliku MPT
 icl 'include\global\global.asm'      ; wszelkie zmienne, stae i struktury uywane przez gr
 icl 'include\global\align.mac'       ; wyrwnanie do pocztku stony
 icl 'include\global\init_nmi.mac'    ; instalacja nowej proc. NMI
 icl 'include\global\@bank_add.mac'   ; makro niezbdne do przeczania bankw sprztowych
 ; icl 'include\loader.asm'         ; mona odhaczy i powstanie plikowa wersja gry, ktr mona wczyta spod dowolnego DOS-a

 org $0600

 .pages $01
 icl 'include\global\@bank_jmp.mac'   ; makro niezbdne do skokw pomidzy bankami sprztowymi

CopyMemory .PROC (.WORD src,dest,len) .var  ; proc. kopiuje obszar pamici o zadanej dugoci w nowe miejsce

src = @proc_vars_adr
dest= @proc_vars_adr+2
len = @proc_vars_adr+4

CopyMem00 LDX dest+1
          LDA len
          BNE CopMem01
          LDY len+1
          BNE CopMem01
          RTS
CopMem01  CPX src+1
          BMI CopMem06
          BNE CopMem02
          LDX dest
          CPX src
          BMI CopMem06
          BEQ CopMem06
CopMem02  LDA src+1
          CLC
          ADC len+1
          STA src+1
          LDA dest+1
          CLC
          ADC len+1
          STA dest+1
          LDY len
          BEQ CopMem05
          BNE CopMem04

CopMem03  LDA (src),Y
          STA (dest),Y
CopMem04  DEY
          BNE CopMem03
          LDA (src),Y
          STA (dest),Y
CopMem05  DEC src+1
          DEC dest+1
          DEC len+1
          LDA len+1
          CMP #$FF
          BNE CopMem04
          RTS

CopMem06  LDY #$00
CopMem07  LDA (src),Y
          STA (dest),Y
          INY
          CPY len
          BCC CopMem07
          LDA len+1
          SNE
          RTS

          LDA src
          CLC
          ADC len
          STA src
          LDA src+1
          ADC #$00
          STA src+1
          LDA dest
          CLC
          ADC len
          STA dest
          LDA dest+1
          ADC #$00
          STA dest+1
CopMem08  LDY #$00
CopMem09  LDA (src),Y
          STA (dest),Y
          INY
          BNE CopMem09
          INC src+1
          INC dest+1
          DEC len+1
          BNE CopMem08
          RTS
.ENDP

FillMemory .PROC (.WORD dest,len .BYTE col) .var    ; procedura wypenia wskazany obszar pamici wartoci 'col'

dest= @proc_vars_adr
len = @proc_vars_adr+2
col = @proc_vars_adr+4

         LDA col
         LDY #$00
         BEQ FillM03
FillM01  STA (dest),Y
         INY
         BNE FillM03
         INC dest+1
FillM03  LDX len
         BNE FillM04
         LDX len+1
         BEQ FillM05
         DEC len+1
FillM04  DEC len
         JMP FillM01
FillM05  RTS
.ENDP
 .endpg

;----------------------------------------------------------------------------------------------------------------------
; Kod odpowiedzialny za przetestowanie iloci dostpnej pamici i w razie braku pamici wywietlenie komunikatu
;----------------------------------------------------------------------------------------------------------------------

 org $8000

 	.link 'include\global\@mem_detect.obx'

detect   jsr @mem_detect
         cmp #13            ; minimum musi by 13*16=208KB   (+64KB pamici podstawowej)
         bcc no_mem
         rts

no_mem   ldx #<AlertMemory  ; Too low memory (must be at least 320KB)
         ldy #>AlertMemory
         stx SDLSTL
         sty SDLSTH
         lda #$00
         sta COLOR4
         lda #$84
         sta COLOR2
         lda #$0F
         sta COLOR1
         jmp *

AlertMemory               ; Display Lista z KOMUNIKATEM o NIEWYSTARCZAjCEJ ILOCI PAMICI
 .BYTE Blank8,Blank8,Blank8
 .BYTE LMS+Mode2,<LowMemory,>LowMemory
 .BYTE Mode2,JVB,<AlertMemory,>AlertMemory

LowMemory
  DTA d'            Too low memory !            '
  DTA d'   You have to have at least 320KB !    '

 ini detect

;----------------------------------------------------------------------------------------------------------------------
; Kod odpowiedzialny za wywietlenie pyncego napisu w intrze
;----------------------------------------------------------------------------------------------------------------------

 lmb #2

 .pages $40

PlayerMPTBank = $4000   ; tu ustawiamy
PlayMPTBank   = $4003   ; to wywoujemy na przerw. VBL
        ins "include\music\PlayMPT.obj",6
YieMusicFX
        mpt_relocator 'include\music\YIEXX22.mpt', YieMusicFX      ; modu z muzyk z gry
YieMusicFX2
        mpt_relocator 'include\music\FX1.mpt', YieMusicFX2         ; modu z muzyk z gry
YieMusicFX3
        mpt_relocator 'include\music\MAGN4B.mpt', YieMusicFX3      ; modu z muzyk tytuow

 .endpg
;--------------------------------------------------------------------------------------------------------------------

 lmb #0

 org $1000

IntroDL
 .byte blank8,blank8,blank8,lms+modeF
DLScr1 .byte <[IntroScr1],>[IntroScr1]
 :95 .byte modeF
 .byte lms+modeF
DLScr2 .byte <[IntroScr1+96*40],>[IntroScr1+96*40]
 :96 .byte modeF
 .byte jvb,<IntroDL,>IntroDL

MusIntro  @BANK_JSR :PlayMPTBank
          jmp $C28A  ;systemowa procedura zdejmujca rejestry A,X,Y ze stosu

ScrollText
          FillMemory #IntroScr1,#40*192*2,#$00   ; wyczy ekrany
          FillMemory #StartBitmap1,#40*190,#$00
          FillMemory #StartBitmap2,#40*190,#$00

          mwa #IntroDL 560                     ; ustaw ekran

          mva #15 709                          ; ustaw kolory
          mva #0  710
          STA 712

          LDA #$00
          LDY #<YieMusicFX
          LDX #>YieMusicFX
          @BANK_JSR :PlayerMPTBank

          LDA #$04
          LDY #%0000
          LDX #IntroMusic
          @BANK_JSR PlayerMPTBank

          LDA VCOUNT
          RNE

          MWA #MusIntro VVBLKD                   ; graj muzyk w intrze

          MWA #StartBitmap1     address4
          MWA #StartBitmap1     address6
          MWA #[192+256]/4      data3
          MVA #255              764

loopScr   CopyMemory address4,#IntroScr2,#40*200
          MWA #IntroScr2       DLScr1
          MWA #IntroScr2+40*96 DLScr2

          lda address6
          add #80
          sta address4
          sta address6
          lda address6+1
          adc #0
          sta address4+1
          sta address6+1

          CopyMemory address4,#IntroScr1,#40*200
          MWA #IntroScr1       DLScr1
          MWA #IntroScr1+40*96 DLScr2

          lda address6
          add #80
          sta address4
          sta address6
          lda address6+1
          adc #0
          sta address4+1
          sta address6+1

          lda 764
          cmp #255
          bne skipScr01

          dew data3
          jne loopScr

skipScr01 LDA       #0
          :8 STA    704+#

          LDA #2
          @BANK_JSR :PlayerMPTBank

          LDA VCOUNT
          RNE

          MWA #$C28A VVBLKD

          RTS

 org $1500

StartBitmap1
 org *+40*190
StartBitmap
	ins "include\bitmaps\start.obx"
StartBitmap2
 org *+40*190

IntroScr1 = $9000-96*40
IntroScr2 = $B000-96*40

 ini ScrollText

;------------------------------------------------------------------------------------------------------------------------
; poka LOGO Yie Ar Kung- Fu, ktre bdzie widoczne na ekranie podczas wczytywania gry
;------------------------------------------------------------------------------------------------------------------------

  org $2000

LOGOonScreen
          LDA    #255            ; stwrz praw i lew ramk - dziki temu pokazuj si kolorowe paski na ramce
          :2 STA    GRAFP0+#
          LDA    #0
          STA    GRAFP2
          STA    GRAFP3
          STA    GRAFM
          LDA    #3
          :4 STA    SIZEP0+#
          STA    SIZEM
          LDA    #16
          STA    HPOSP0
          LDA    #208
          STA    HPOSP1
          LDA    #4
          STA    GPRIOR
          LDA    #1
          STA    GRACTL

          LDA    #<DListLOGOStart    ; program dla ANTIC
          STA    SDLSTL
          LDA    #>DListLOGOStart
          STA    SDLSTH

          LDA    #3*16+0             ; ustaw kolory
          STA    708
          LDA    #3*16+6
          STA    709
          LDA    #3*16+4
          STA    710
          RTS

 org $A000

LOGOStart
	ins 'include\bitmaps\yieload.obx'

DListLOGOStart
 :13 .byte Blank8
 .byte LMS+ModeE,<LOGOStart,>LOGOStart
 :31 .byte ModeE
 .byte JVB,<DListLOGOStart,>DListLOGOStart

 ini LOGOonScreen

;----------------------------------------------------------------------------------------------------------------------
; Bitmapy z 1-szym i 2-gim ekranem gry - aduj do pamici gwnej
; Bitmapy z ekranem tytuowym i 3-cim ekranem gry - aduj do BANKU nr.0
; Bitmap z ekranem kocowym - aduj do BANKU nr.1
; Kolejne klatki animacji gwnego bohatera oraz ekran z drzwiami - aduj do BANKU nr.2
; Kolejne klatki animacji przeciwnikw - aduj do BANKW nr.3,4,5,6
; Display List-a dla ekranu walki, z drzwiami oraz dla ekranu z wynikami gry do BANKU nr.7
;----------------------------------------------------------------------------------------------------------------------
	icl 'include\datas.asm'
	icl 'include\ProcBank.asm'
;----------------------------------------------------------------------------------------------------------------------

 org $8000

;------------------------------------------------------------------------------------------------------------------------
; Procedura konwertujca klatki animacyjne Player'a na ich lustrzane odbicie (czyli prawo->lewo lub lewo->prawo)
;------------------------------------------------------------------------------------------------------------------------
MirrorPlayer
         JSR L16AC
         mva BANKS+2 PORTB
         mva #$FF    L8206
         STA L8207
         STA L8208
         STA L8209
         STA L820A
         STA L820B

         ldy #$00

mir_pla1 lda #$00

         JSR L81E1
         JSR L16E9
         JSR L81C2
         JSR L16E9

         mva #$00 L8190+1

         JSR L817C
         JSR L80DC

         STA ($00E1),Y
         mva #$03 L8190+1

         JSR L817C
         JSR L80F7

         LDA ($00E1),Y
         ORA POKADR
         STA ($00E1),Y
         mva #$00 L8190+1

         JSR L817C
         JSR L80DC
         JSR L8117

         rol @
         ror POKADR
         rol @
         ror DATALN
         rol POKADR
         ror DATALN
         rol @
         ror POKADR
         rol @
         ror DATALN
         rol POKADR
         ror DATALN
         rol @
         ror POKADR
         rol @
         ror DATALN
         rol POKADR
         ror DATALN
         lsr DATALN
         lsr DATALN

         mva DATALN ($00B1),Y
         mva #$00   DATALN
         mva #$03   L8190+1

         JSR L817C
         JSR L80F7
         JSR L8117

         ror @
         rol POKADR
         ror @
         rol DATALN
         ror POKADR
         rol DATALN
         ror @
         rol POKADR
         ror @
         rol DATALN
         ror POKADR
         rol DATALN
         ror @
         rol POKADR
         ror @
         rol DATALN
         ror POKADR
         rol DATALN
         asl DATALN
         asl DATALN

         lda ($00B1),Y
         ora DATALN
         sta ($00B1),Y

         JSR L16E9

         mva #$FF L8206
         STA L8207
         STA L8208
         STA L8209
         STA L820A
         STA L820B

         iny
         cpy #$30
         jne mir_pla1

         rts
mir1 .byte 0
;----------------------------
L80DC    and #$F0
         sta mir1
         lda #$00
         asl mir1
         rol @
         asl mir1
         rol @
         clc
         rol @
         rol @
         asl mir1
         rol @
         asl mir1
         rol @
         rts
;----------------------------
L80F7    and #$F0
         sta mir1
         lda #$00
         asl mir1
         rol @
         asl mir1
         rol @
         clc
         rol @
         rol @
         asl mir1
         rol @
         asl mir1
         rol @
         clc
         rol @
         rol @
         sta POKADR
         rts
;--------------------------------
L8117    asl @
         ror L813B
         asl @
         ror L813B
         asl @
         ror L813B
         asl @
         ror L813B
         asl @
         ror L813B
         asl @
         ror L813B
         asl @
         ror L813B
         asl @
         ror L813B
         lda L813B
         rts
L813B .byte 0
;--------------------------------
L813C    asl @    ; odwrcenie bajtu w akumulatorze - jego bitw np.
         ror L813B
         asl @
         ror L817B
         rol L813B
         ror L817B
         asl @
         ror L813B
         asl @
         ror L817B
         rol L813B
         ror L817B
         asl @
         ror L813B
         asl @
         ror L817B
         rol L813B
         ror L817B
         asl @
         ror L813B
         asl @
         ror L817B
         rol L813B
         ror L817B
         lda L817B
;----------------------------------
; Robi kolorowe paski na Graczu PMG P0 i P1
BarsOnBorder
         sta COLPM0
         sta COLPM1
         sta StoreBorder
         lda VCOUNT
         cmp #15
         bcc SkipBorder01
         cmp #110
         bcs SkipBorder01

         mva #0 COLBK
         lda StoreBorder
         rts

SkipBorder01
         lda StoreBorder
         sta COLBK
         lda StoreBorder
         rts
StoreBorder .byte 0
;----------------------------------
L817B .byte 0
L817C    tya
         pha
         mvy #$00 POKADR
         iny
         sty VVTP

L8185    LDX #$04
         LDA (RUNSTK+1),Y
L8189    TAY
         AND #$03
         CMP #$02
         BEQ L8194
L8190    CMP #$03
         BNE L81AB

L8194    SEC
         ror POKADR
         TYA
         lsr @
         lsr @
         DEX
         BNE L8189
         LDY #$00
         DEC VVTP
         BPL L8185
         PLA
         TAY
         LDA POKADR
         JMP BarsOnBorder

L81AB    CLC
         ror POKADR
         TYA
         lsr @
         lsr @
         DEX
         BNE L8189
         LDY #$00
         DEC VVTP
         BPL L8185
         PLA
         TAY
         LDA POKADR
         JMP BarsOnBorder
;------------------------------
L81C2    LDA #$00
         STA L8190+1
         JSR L817C
         STA ($00DD),Y
         JSR L8117
         STA ($00AD),Y
         LDA #$03
         STA L8190+1
         JSR L817C
         STA ($00DF),Y
         JSR L8117
         STA ($00AF),Y
         RTS
;----------------------------------------
L81E1    LDA #$00
         STA L8190+1
         JSR L817C
         STA ($00D9),Y
         JSR L8117
         STA ($00A9),Y
         LDA #$03
         STA L8190+1
         JSR L817C
         STA ($00DB),Y
         JSR L8117
         STA ($00AB),Y
         RTS
;----------------------------------------
         BRK
         BRK
         BRK
         BRK
         BRK
         BRK
L8206    .byte 0
L8207    .byte 0
L8208    .byte 0
L8209    .byte 0
L820A    .byte 0
L820B    .byte 0
MirrorTAB1
         ORA (NGFLAG,X)
         ORA (NGFLAG,X)
         ORA (NGFLAG,X)
         ORA (RECVDN,X)

;------------------------------------------------------------------------------------------------------------------------
; Procedura konwertujca klatki animacyjne Opponent'w na ich lustrzane odbicia (czyli prawo->lewo lub lewo->prawo)
;------------------------------------------------------------------------------------------------------------------------
MirrorOpponent
         LDA $009D     ;oblicz adres kolejnej klatki
         STA $00D9
         CLC
         ADC #$82     ;<386
         STA $00A9
         LDA $009E
         STA FRE
         ADC #$01     ;>386
         STA $00AA

         LDA $00C4    ;ustaw odpowiedzni bank dla danej klatki
         lsr @
         TAY
         LDA OpponentClipBank,Y
         TAY
         LDA BANKS+0,Y
         STA PORTB

         LDX #$00
MirrorOpponent2
         LDY #$00                 ;pobiera kolejne bajty spod ($00D9)
         LDA ($00D9),Y         ;robi lustrzne odbicie bitw
         JSR L813C                ;zapisuje w nastpnej klatce jednak niepokolei, ale w formacie znak(co 8-siem)
         LDY #$38                 ;poza tym zapisuje od prawej do lewej
         STA ($00A9),Y
         LDY #$01
         LDA ($00D9),Y
         JSR L813C
         LDY #$30
         STA ($00A9),Y
         LDY #$02
         LDA ($00D9),Y
         JSR L813C
         LDY #$28
         STA ($00A9),Y
         LDY #$03
         LDA ($00D9),Y
         JSR L813C
         LDY #$20
         STA ($00A9),Y
         LDY #$04
         LDA ($00D9),Y
         JSR L813C
         LDY #$18
         STA ($00A9),Y
         LDY #$05
         LDA ($00D9),Y
         JSR L813C
         LDY #$10
         STA ($00A9),Y
         LDY #$06
         LDA ($00D9),Y
         JSR L813C
         LDY #$08
         STA ($00A9),Y
         LDY #$07
         LDA ($00D9),Y
         JSR L813C
         LDY #$00
         STA ($00A9),Y

         LDA $00D9
         CLC
         ADC #$08
         STA $00D9
         LDA FRE
         ADC #$00
         STA FRE

         TXA
         PHA
         AND #$07
         TAX
         LDA $00A9
         CLC
         ADC MirrorTAB1,X
         STA $00A9
         LDA $00AA
         ADC #$00
         STA $00AA

         PLA
         TAX
         INX
         CPX #$30
         BNE MirrorOpponent2

         LDA $009D     ;odtworzenie adresu klatki
         STA $00A9
         CLC
         ADC #$82
         STA $00D9  ;stworzenie adresu wskazujcego na nastpn klatk
         LDA $009E
         STA $00AA
         ADC #$01
         STA FRE

         LDX #$00
MirrorOpponent3
         LDY #$00            ;pobiera co 8-my bajt spod ($00D9)
         LDA ($00D9),Y    ;robi lustrzne odbicie bitw
         JSR L813C           ;zapisuje w poprzedzajcej klatce jednak niepokolei, ale w formacie znak(co 8-siem)
         LDY #$38            ;poza tym zapisuje od prawej do lewej
         STA ($00A9),Y
         LDY #$08
         LDA ($00D9),Y
         JSR L813C
         LDY #$30
         STA ($00A9),Y
         LDY #$10
         LDA ($00D9),Y
         JSR L813C
         LDY #$28
         STA ($00A9),Y
         LDY #$18
         LDA ($00D9),Y
         JSR L813C
         LDY #$20
         STA ($00A9),Y
         LDY #$20
         LDA ($00D9),Y
         JSR L813C
         LDY #$18
         STA ($00A9),Y
         LDY #$28
         LDA ($00D9),Y
         JSR L813C
         LDY #$10
         STA ($00A9),Y
         LDY #$30
         LDA ($00D9),Y
         JSR L813C
         LDY #$08
         STA ($00A9),Y
         LDY #$38
         LDA ($00D9),Y
         JSR L813C
         LDY #$00
         STA ($00A9),Y

         TXA
         PHA
         AND #$07
         TAX
         LDA $00D9
         add MirrorTAB1,X
         STA $00D9
         LDA FRE
         ADC #$00
         STA FRE

         LDA $00A9
         CLC
         ADC MirrorTAB1,X
         STA $00A9
         LDA $00AA
         ADC #$00
         STA $00AA

         PLA
         TAX
         INX
         CPX #$30
         BNE MirrorOpponent3
         RTS
;------------------------------
L16AC    LDA RUNSTK+1
         CLC
         ADC #$21
         STA $00D9
         LDA TOPSTK
         ADC #$01
         STA FRE
         LDA $00D9
         CLC
         ADC #$F0
         STA $00A9
         LDA FRE
         ADC #$00
         STA $00AA
         LDX #$00
L16C8    LDA $00D9,X
         CLC
         ADC #$30
         STA $00DB,X
         LDA FRE,X
         ADC #$00
         STA FRE+2,X
         LDA $00A9,X
         CLC
         ADC #$30
         STA $00AB,X
         LDA $00AA,X
         ADC #$00
         STA $00AC,X
         INX
         INX
         CPX #$0A
         BNE L16C8
         RTS
;--------------------------------------
L16E9    LDA RUNSTK+1
         CLC
         ADC #$02
         STA RUNSTK+1
         LDA TOPSTK
         ADC #$00
         STA TOPSTK
         RTS
;--------------------------------------
MirrorFrames .PROC
         LDX #<MirrorPlayerTAB
         LDY #>MirrorPlayerTAB
         STX FR2+5
         STY FRX

         LDY #0  ;0
StGame1  LDA (FR2+5),Y
         STA RUNSTK+1
         INY
         LDA (FR2+5),Y
         STA TOPSTK
         TYA
         PHA
         JSR MirrorPlayer ;$8000
         PLA
         TAY
         INY
         CPY #$20
         BNE StGame1

         LDX #<MirrorOpponentTAB
         LDY #>MirrorOpponentTAB
         STX FR2+5
         STY FRX
         LDY #0  ;0
StGame2  STY $00C4
         LDA (FR2+5),Y
         STA $009D
         INY
         LDA (FR2+5),Y
         STA $009E

         TYA
         PHA
         JSR MirrorOpponent ;$8214
         PLA
         TAY
         INY
         CPY #LenMirrorOpponentTAB ;146+8   ;4 klatki dodatkowe
         BNE StGame2
         RTS
.ENDP

MirrorPlayerTAB
 .BYTE 0,64,1,67,2,70,3,73,4,76,5,79,6,82,7,85,8,88   ;adresy klatek w Bank 2
 .BYTE 9,91,10,94,11,97,12,100,13,103,14,106,15,109

MirrorOpponentTAB
 .BYTE 24,88,27,91,30,94,33,97,36,100,39,103,42,106   ;adresy klatek w Bank 3
 .BYTE 0,64,3,67,6,70,9,73,12,76,15,79,18,82,21,85

 .BYTE 0,64,3,67,6,70,9,73,12,76,15,79,18,82,21,85    ;adresy klatek w Bank 4
 .BYTE 24,88,27,91,30,94,33,97,36,100,39,103,42,106
 .BYTE 45,109,48,112,51,115,54,118,<:PoleClipsDead,>:PoleClipsDead,<:PoleStickMiddle,>:PoleStickMiddle

 .BYTE 0,64,3,67,6,70,9,73,12,76,15,79,18,82,21,85    ;adresy klatek w Bank 5
 .BYTE 24,88,27,91,30,94,33,97,36,100,39,103,42,106
 .BYTE 45,109,48,112,51,115,<:FanClipsDead,>:FanClipsDead

 .BYTE 0,64,3,67,6,70,9,73,12,76,15,79,18,82,21,85    ;adresy klatek w Bank 6
 .BYTE 24,88,27,91,30,94,33,97

 .BYTE <:BlueClipsLeft,>:BlueClipsLeft,<:BlueClipsRight,>:BlueClipsRight
 .BYTE <:BlueClipsKickDown,>:BlueClipsKickDown,<:BlueClipsFistMiddle,>:BlueClipsFistMiddle
 .BYTE <:BlueClipsKickMiddle,>:BlueClipsKickMiddle,<:BlueClipsKickBack,>:BlueClipsKickBack
 .BYTE <:BlueClipsFistUpper,>:BlueClipsFistUpper                                        ;adresy klatek w Bank 14
 .BYTE <:BlueClipsKickUpper,>:BlueClipsKickUpper,<:BlueClipsDead,>:BlueClipsDead

 .BYTE 45,109,48,112,51,115,54,118,57,121             ;adresy klatek w Bank 3

 .BYTE 141,115                                        ;adres drzwi w Banku 2

LenMirrorOpponentTAB = *-MirrorOpponentTAB

;----------------------------------------------------------------------------------------------------------------------
; kolejne Display Listy
;----------------------------------------------------------------------------------------------------------------------

 org $0C00

DListGameOver
 .BYTE Blank8,Blank8,Blank4
 .BYTE LMS+Mode4,<Screen40x25,>Screen40x25
 .BYTE Mode4,Mode4+DLI,Mode4,Mode4,Mode4+DLI,Mode4,Mode4,Mode4+DLI,Mode4,Mode4
 .BYTE Mode4+DLI,Mode4,Mode4,Mode4+DLI,Mode4,Mode4,Mode2+DLI,Mode2,Mode2,Mode4+DLI,Mode4,Mode4,Mode4+DLI,Mode4
 .BYTE JVB,<DListGameOver,>DListGameOver
DListDoors
 .BYTE Blank8,Blank8+DLI,Blank4
 .BYTE LMS+Mode2,<Screen40x25,>Screen40x25
 .BYTE Mode2,Mode2,Mode2,Mode2,Mode2
 .BYTE Blank8+DLI,Mode4,Mode4,Mode4+DLI,Mode4,Mode4,Mode4+DLI,Mode4,Mode2,Mode4+DLI
 .BYTE Mode4,Mode4,Mode4+DLI,Mode4,Mode4,Mode4+DLI,Mode4,Mode4,Mode2+DLI,Blank8
 .BYTE JVB,<DListDoors,>DListDoors
DListScore
 .BYTE Blank8,Blank8,Blank4
 .BYTE LMS+Mode4,<Screen40x25,>Screen40x25
 .BYTE Mode4,Mode4+DLI,Mode2,Mode2,Mode2,Mode2,Mode2,Mode2,Mode2,Mode2,Mode2,Mode2
 .BYTE Mode2,Mode2,Mode2,Mode2,Mode2,Mode2,Mode2,Mode2+DLI,Blank8,Mode4,Mode4,Mode4
 .BYTE JVB,<DListScore,>DListScore
DListTitle
 .BYTE Blank8,Blank8,Blank4
 .BYTE LMS+Mode4,<Screen40x25,>Screen40x25
 .BYTE Mode4,Mode4+DLI,Mode4,Mode4,Mode4+DLI,Mode4,Mode4,Mode4+DLI,Mode4,Mode4
 .BYTE Mode4+DLI,Mode4,Mode4,Mode4+DLI,Mode4,Mode4,Mode4+DLI,Mode4,Mode4,Mode4+DLI
 .BYTE Mode4,Mode4,Mode4+DLI,Mode4
 .BYTE JVB,<DListTitle,>DListTitle
DListPlayers
 .BYTE Blank8,Blank8,Blank8,Blank2,LMS+Mode4,<Screen40x25,>Screen40x25,Mode4,Mode4+DLI,Mode4,Mode4,Mode4+DLI
 .BYTE Mode4,Mode4,Mode4+DLI,Mode2,Mode2,Mode2+DLI,Mode2,Mode2
 .BYTE Mode2+DLI,Mode2,Mode2,Mode2+DLI,Mode2,Blank6,Mode4,Mode4+DLI,Mode4 ;,Mode4,Mode4+DLI,Mode4
 .BYTE JVB,<DListPlayers,>DListPlayers
DListPlayfield1
 .BYTE Blank8,Blank8+DLI,Blank4
 .BYTE LMS+Mode2,<Screen48x25,>Screen48x25
 .BYTE Mode2,Mode2+DLI,Mode4,Mode4,Mode4+DLI,Mode4,Mode4,Mode4+DLI,Mode4,Mode4,Mode4+DLI,Mode4,Mode4,Mode4+DLI
 .BYTE Mode4,Mode4,Mode4+DLI,Mode4,Mode4,Mode4+DLI,Mode4,Mode4,Mode4+DLI,Mode4+DLI
 .BYTE LMS+ModeF,<Screen48x1,>Screen48x1
 .BYTE ModeF,ModeF,ModeF,ModeF,ModeF,ModeF,ModeF,ModeF
 .BYTE JVB,<DListPlayfield1,>DListPlayfield1
DListPlayfield2
 .BYTE Blank8,Blank8+DLI,Blank4
 .BYTE LMS+Mode2,<Screen48x25,>Screen48x25
 .BYTE Mode2,Mode2+DLI,Mode4,Mode4,Mode4+DLI,Mode4,Mode4,Mode4+DLI,Mode4,Mode4+DLI,Mode4+DLI,Mode4,Mode4+DLI,Mode4+DLI
 .BYTE Mode4,Mode4,Mode4+DLI,Mode4,Mode4,Mode4+DLI,Mode4,Mode4,Mode4+DLI,Mode4+DLI
 .BYTE LMS+ModeF,<Screen48x1,>Screen48x1
 .BYTE ModeF,ModeF,ModeF,ModeF,ModeF,ModeF,ModeF,ModeF
 .BYTE JVB,<DListPlayfield2,>DListPlayfield2
DListStage
 .BYTE Blank8,Blank8+DLI,Blank4
 .BYTE LMS+Mode2,<Screen40x25,>Screen40x25
 .BYTE Mode2,Mode2,Mode2,Mode2,Mode2,Mode2,Mode2,Mode2,Mode2,Mode2,Mode2,Mode2
 .BYTE Mode2,Mode2,Mode2,Mode2,Mode2,Mode2,Mode2,Mode2,Mode2,Mode2,Mode2,Mode2
 .BYTE JVB,<DListStage,>DListStage
DListWinnerScreen
 .BYTE Blank8,Blank8,Blank4
 .BYTE LMS+Mode2,<Screen40x25,>Screen40x25
 .BYTE Mode2,Mode2+DLI,Mode2,Mode2,Mode4+DLI,Mode4,Mode4,Mode4+DLI,Mode4,Mode4
 .BYTE Mode4+DLI,Mode4,Mode4,Mode4+DLI,Mode4,Mode4,Mode4+DLI,Mode2,Mode2,Mode2+DLI,Mode2,Mode2,Mode2+DLI,Mode2
 .BYTE JVB,<DListWinnerScreen,>DListWinnerScreen

;------------------------------------
; rezerwacja pamici dla przerwa DLI, ktre s kopiowane z pamici rozszerzonej w to miejsce i std uruchamiane
memory_reserved_for_DLI
 org *+:DLISecond.len             ; rezerwacja takiej iloci pamici jak ma najdusza procedura obsug. przerw. DLI

;------------------------------------
; Procedura migajca "1"
BlinkPlayer
         dec CounterBlinkPlayer
         bne Blink02

         mva #20 CounterBlinkPlayer

         lda Screen48x25+8+4
         bne Blink01

         lda ActivePlayer
         add #16
         sta Screen48x25+8+4 ;(1)
         rts

Blink01  mva #0  Screen48x25+8+4
Blink02  rts
;------------------------------------
; Wywietla doln strzak, ktra wskazuje kierunek ostatniego ruchu gracza
IsEnableArrow    .BYTE 0
StorePORTATrig0  .byte 0
ArrowPORTA       .byte 0

ShowArrow
         LDA PORTB
         PHA
         mva @TAB_MEM_BANKS+8 PORTB
         JSR :ShowArrowBank
         PLA
         STA PORTB
         RTS
;----------------------------------------------
; Dlist Interrupt for First/Second Door Screen & Second/Third Playfield & End Screen
; Tutaj jest procedura ustawiajca wygld i kolory sla grnej poowy ekranu z energi, punktami itd.
SetUpperScreen
         LDA #$03
         STA SIZEP0
         STA SIZEP1
         STA SIZEP2
         STA SIZEP3
         LDA #0
         STA COLPF2
         LDA #$5C
         STA HPOSP0
         LDA #$84
         STA HPOSP1
         LDA #$A4+3*4
         STA HPOSP2
         JSR SetAddrCharsetsTAB
         LDX #$0A-2
         LDY #$0E-2
         :3 STX WSYNC
         STX COLPF1
         STA WSYNC
         STY COLPF1
         :5 STA WSYNC
         STX COLPF1
         :2 STA WSYNC
         LDA #$54-2
         STA COLPM2
         STA WSYNC
         STY COLPF1
         STA WSYNC
         LDA #$56-2
         STA COLPM2
         :4 STA WSYNC
         STX COLPF1
         LDA #$54-2
         STA COLPM2
         :2 STA WSYNC
         LDA #$32-2
         STA COLPM0
         STA COLPM1
         STA WSYNC
         STY COLPF1
         STA WSYNC
         LDA #$34-2
         STA COLPM0
         STA COLPM1
         :4 STA WSYNC
         LDA #$32-2
         STA COLPM0
         STA COLPM1
         STX COLPF1
         LDA #$00
         STA Index1
VBL_RTS  RTS
;----------------------------------
AddrCharsetsTABChange .BYTE >[Screen160x200Buffor1+$0400],>[Screen160x200Buffor2+$0400]

SetAddrCharsetsTAB
         LDX IsAnimateWaterfall
         BNE SetAddr2
         LDX ChangeScreenBuffor
         LDA AddrCharsetsTABChange,X
         LDX #$00
         CLC
SetAddr1 STA AddrCharsetsTAB,X
         ADC #$04
         INX
         CPX #9
         BNE SetAddr1
         RTS

SetAddr2 LDX #$00
         LDA AddrCharsetsTABChange
         CLC
SetAddr3 STA AddrCharsetsTAB,X
         ADC #$04
         INX
         CPX #5
         BNE SetAddr3

         LDY ChangeScreenBuffor
         LDA AddrCharsetsTABChange,Y
         CLC
         ADC #4*5

         CLC
SetAddr4 STA AddrCharsetsTAB,X
         ADC #$04
         INX
         CPX #9 
         BNE SetAddr4
         RTS
;---------------------------------
CounterBlinkPlayer .byte 0 ; przydatne w procedurze Blink dla "1" (licznik co ile jednostek 1/50s miga)
ActivePlayer       .byte 1 ; ktry player aktualnie gra (1 lub 2)
AttackPlayer       .byte 0 ; jaki by poprzedni cios wykonany prze Playera?
StorePRIOR         .byte 33
AddrCharsetsTAB    .byte $84,$88,$8C,$90,$94,$98,$9C,$A0,$A4  ; zawiera 9 starszych adresw kolejnych zestaww znakw (dla DLI)
;--------------------------------------
WaitKey  LDA #$FF
         STA CH
WaitKey1 LDA CH
         CMP #$FF
         BEQ WaitKey1
         STA CH
         RTS
;--------------------------------------
CounterRowsDraw .byte 0
CounterDraw1    .byte 0
DrawBitmapL
 :8 .byte <[320*[#*3]+#*64],<[320*[#*3+1]+#*64],<[320*[#*3+2]+#*64]
    .byte <[320*24+512]
DrawBitmapH
 :8 .byte >[320*[#*3]+#*64],>[320*[#*3+1]+#*64],>[320*[#*3+2]+#*64]
    .byte >[320*24+512]

DrawBitmapY      .byte 0   ; Y - wiersz], od ktrej ma by rozpoczte rysowanie obrazka (bity od 0,1,2 nie s brane
                           ; pod uwag)
StoreDrawA       .byte 0

DrawBitmapOnScreenBuffors  ;rysuje na obu buforach
         STA StoreDrawA
         TXA
         PHA
         TYA
         PHA
         LDA DrawBitmapY
         PHA
         LDA StoreDrawA
         JSR DrawBitmapOnScreenBuffor1
         PLA
         STA DrawBitmapY
         PLA
         TAY
         PLA
         TAX
         LDA StoreDrawA

DrawBitmapOnScreenBuffor2           ;rysuje bitmap(adres w YX) na drugim buforze
         STA CounterRowsDraw
         MVA #<Screen160x200Buffor2 DrawB01+1
         MVA #>Screen160x200Buffor2 DrawB02+1
         BNE DrawBitmapSettings ;jmp
; X i Y - adres obrazka  A - liczba linii do narysowania
; Rysuje na pierwszym buforze tylko
; UWAGA: rysuje od wiersza wpisanej w DrawBitmapY (bez bitw 0,1,2)
DrawBitmapOnScreenBuffor1
         STA CounterRowsDraw
         MVA #<Screen160x200Buffor1 DrawB01+1
         MVA #>Screen160x200Buffor1 DrawB02+1
DrawBitmapSettings
         STX DrAddr01+1
         STY DrAddr01+2

         LDX DrawBitmapY
         LDA DrawBitmapL,X
         CLC
DrawB01  ADC #<Screen160x200Buffor1
         STA DrAddr02+1
         LDA DrawBitmapH,X
DrawB02  ADC #>Screen160x200Buffor1
         STA DrAddr02+2

         JSR DrawBitmapAll

         LDA #0
         STA DrawBitmapY
         RTS

DrawBitmapAll
         JSR DrawBitmapRow

         LDA DrAddr01+1
         SEC
         SBC #<192
         STA DrAddr01+1
         LDA DrAddr01+2
         SBC #>192
         STA DrAddr01+2

         LDX DrawBitmapY
         LDA DrAddr02+1
         CLC
         ADC Add312OpponentTABL,X
         STA DrAddr02+1
         LDA DrAddr02+2
         ADC Add312OpponentTABH,X
         STA DrAddr02+2
         INC DrawBitmapY

         DEC CounterRowsDraw
         BNE DrawBitmapAll

         RTS

DrawBitmapRow
         LDA #0
         STA DrCMP00+1
         STA DrCMP01+1

         LDA #<DrawBitmapRow03
         STA DrJump1+3
         LDA #>DrawBitmapRow03
         STA DrJump1+4

         LDA #2
         STA CounterDraw1

         LDX #0
         LDY #0
DrawBitmapRow01
DrAddr01 LDA $FFFF,Y      ;pobierz co bajt
DrAddr02 STA $FFFF,X      ;rysuj co 8 bo ukad znakowy na ekranie

         TXA
         CLC
         ADC #8
         TAX
DrCMP00  CPX #0
DrJump1  BNE DrawBitmapRow02 ;DrawBitmapRow03
         JMP DrawBitmapRow03

DrawBitmapRow02
         INY
DrCMP01  CPY #0
         BNE DrawBitmapRow01

         INC DrAddr01+2

         LDA #64
         STA DrCMP01+1
         DEC CounterDraw1
         BNE DrawBitmapRow01

         RTS

DrawBitmapRow03
         LDA #<DrawBitmapRow04
         STA DrJump1+3
         LDA #>DrawBitmapRow04
         STA DrJump1+4

         INC DrAddr02+2
         LDA #64
         STA DrCMP00+1
         BNE DrawBitmapRow02 ;JMP

DrawBitmapRow04
         LDA #<DrawBitmapRow03
         STA DrJump1+3
         LDA #>DrawBitmapRow03
         STA DrJump1+4

         DEC DrAddr02+2
         INC DrAddr02+1
         SNE
         INC DrAddr02+2
         LDA #0
         STA DrCMP00+1
         TAX
         BEQ DrawBitmapRow02 ;JMP
;----------------------------------
ShowScoreText
         LDA PORTB
         PHA
         LDA BANKS+7
         STA PORTB
         JSR :ShowScoreTextBank
         PLA
         STA PORTB
         RTS
;---------------------------------------------
; Dlist Interrupt for First,Second,Third Playfield
SetPlayerVBL
         LDA #color_player1
         STA COLPM0
         STA COLPM2
         LDA #color_player2
         STA COLPM1
         STA COLPM3
         LDA #$00
         STA SIZEP0
         STA SIZEP1
         STA SIZEP2
         STA SIZEP3
         STA SIZEM
         LDA :StoreHPOSP0
         STA HPOSP0
         LDA :StoreHPOSP1
         STA HPOSP1
         LDA :StoreHPOSP2
         STA HPOSP2
         LDA :StoreHPOSP3
         STA HPOSP3
         LDA :StoreHPOSM0
         STA HPOSM0
         LDA :StoreHPOSM1
         STA HPOSM1
         LDA :StoreHPOSM2
         STA HPOSM2
         LDA :StoreHPOSM3
         STA HPOSM3
         lda :StoreSIZEM
         sta SIZEM
         RTS
;---------------------------------------------
SetClearPMG
         LDA PORTB
         PHA
         LDA BANKS+7
         STA PORTB
         JSR :SetClearPMGBank
         PLA
         STA PORTB
         RTS
;---------------------------------------------
CreateUpperTextOnScreenNew
         LDA PORTB
         PHA
         LDA BANKS+7
         STA PORTB
         JSR :CreateUpperTextOnScreenNewBank
         PLA
         STA PORTB
         RTS

;--------------------------------------------
Bar01    .BYTE $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF    ; pasek energii - gracz 1
Bar02    .BYTE $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF    ; pasek energii - gracz 2
Bar03pl1 .BYTE $F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8    ; pasek ycia   - gracz 1
Bar03pl2 .BYTE $F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8    ; pasek ycia   - gracz 2

;--------------------------------------------
NMIInterrupt                ; wasne przerwanie NMI
         BIT NMIRES
         SPL
         JMP (VDSLST)       ; to jest przerwanie DLI

         STA NMIRES         ; to jest przerwanie VBL
         PHA
         TYA
         PHA
         TXA
         PHA

         DEC TIMER          ; zmniejszane podczas kadego przerw. VBL (255..0)
         LDA GRAFP3
         STA STRIG0
         LDA GRAFM
         STA STRIG1
         LDA PORTA
         AND #$0F
         STA STICK0
         :4 lsr @
         STA STICK1
         LDA SDMCTL
         STA DMACLT
         LDA GPRIOR
         STA PRIOR
         LDA PCOLR0
         STA COLPM0
         LDA PCOLR1
         STA COLPM1
         LDA PCOLR2
         STA COLPM2
         LDA PCOLR3
         STA COLPM3
         LDA COLOR0
         STA COLPF0
         LDA COLOR1
         STA COLPF1
         LDA COLOR2
         STA COLPF2
         LDA COLOR3
         STA COLPF3
         LDA COLOR4
         STA COLBK
         LDA CHBAS
         STA CHBASE
         LDA SDLSTL
         STA DLISTL
         LDA SDLSTH
         STA DLISTH
         LDA SKCTL
         AND #$04
         BNE VBLInt03
         LDA KBCODE
         CMP CH1
         BEQ VBLInt04
         STA CH
         STA CH1
         JMP VBLInt04
VBLInt03 LDA #$FF
         STA CH1
VBLInt04 JSR ExecVVBLKI
         PLA
         TAX
         PLA
         TAY
         PLA
DLIRTI   RTI

ExecVVBLKI  ; skok do dodatkowej cz przerwania VBL
         JMP (VVBLKI)

TIMER .byte 0               ; zmniejszane podczas kadego przerw. VBL (255..0) - wykorzystywane np. przez ScreenOFF/ON
;-----------------------------------
IsAnimateWaterfall    .byte 0
; Tablica 9 bajtw, w ktrej zachowywane s wszystkie kolory
TABColors .byte 0,0,0,0,0,0,0,0,0
;-----------------------------------------------------------
Music       .byte 0
IsPlayMusic .byte 0

InitMPT
       LDA PORTB
       PHA
       LDA Banks+1
       STA PORTB
       LDA #1
       STA IsPlayMusic
       LDA #$00
       @BANK_JSR :PlayerMPTBank
       PLA
       STA PORTB
       RTS
;-----------------------------------------------------------
PlayFXStore .byte 0
PlayFX STA PlayFXStore
       LDA PORTB
       PHA
       LDA Banks+1
       STA PORTB

       LDA PlayFXStore
       ORA #$03*$40
       TAX
       LDA #$01
       LDY #$00
       @BANK_JSR :PlayerMPTBank

       PLA
       STA PORTB
       RTS
;-----------------------------------------------------------
IsPlayOnVBL_FX .byte 0  ; =1 odgrywaj dwik turn_nuncha_FX=$05 na VBL
CounterFX      .byte 0  ; co ile ramek odgrywa FX na VBL-u
CounterFXs     .byte 0  ; co ile ramek odgrywa FX na VBL-u, cie
NoteFX         .byte 0  ; na jakiej nucie odgrywa FX-a na VBL-u

PlayFXonVBL .MACRO
       lda #1
       sta IsPlayOnVBL_FX
.ENDM

StopFXonVBL .MACRO
       lda #0
       sta IsPlayOnVBL_FX
.ENDM
;-----------------------------------------------------------
PlaySongMPT ;X- pozycja songu w pliku *.mpt
       LDA PORTB
       PHA
       LDA Banks+1
       STA PORTB

       LDA #$04
       LDY #%0000
       JSR :PlayerMPTBank

       PLA
       STA PORTB
       RTS
;-----------------------------------------------------------
StopMPT
       LDA PORTB
       PHA
       LDA Banks+1
       STA PORTB
       LDA #0
       STA IsPlayMusic
       LDA #2
       @BANK_JSR :PlayerMPTBank
       PLA
       STA PORTB
       RTS
;-----------------------------------------------------------
ScreenOFF .PROC
         lda SDMCTL			; wycz wywietlanie PMG i ekranu
         and #%11000011
         sta SDMCTL

         lda:cmp:req TIMER      	; poczekaj a rejestr cie SDMCTL zostanie przepisany do DMACTL

         rts
.ENDP
;-----------------------------------------------------------
ScreenON .PROC
         lda SDMCTL			; wcz wywietlanie PMG i ekranu
         ora #%00111100
         sta SDMCTL
         MVA #3         GRACTL

         lda:cmp:req TIMER      	; poczekaj a rejestr cie SDMCTL zostanie przepisany do DMACTL

         MVA #%11000000 NMIEN

         rts
.ENDP

;------------------------------------------------------------------------------------------------------------------------
; Tutaj startuje gra po wczytaniu
;------------------------------------------------------------------------------------------------------------------------
RunGame  init_nmi $14,NMIInterrupt,$c0    ; ta procka w rodku troch zmodyfikowana bo ustaw. te przerw. VBL i DLI

         ldx #64                          ; nie ma ju OS wic nie wolno go wcza rwnie przy zmianie bankw!
StartG01 lda @TAB_MEM_BANKS,x
         and #254
         sta @TAB_MEM_BANKS,x
         dex
         bpl StartG01

         MVA @TAB_MEM_BANKS+3 PORTB                ; instaluje font 8x8 (dane fontu w banku nr. 3)
         CopyMemory #:font8x8_part1,#$F000,#$0200  ; instaluje tylko znaki wykorzystywane w foncie (wic nie cay 1KB)
         CopyMemory #:font8x8_part2,#$F300,#$0100
         CopyMemory #:font8x8_part3,#$F010,#$0020

         MirrorFrames                     ; proc. tworzy klatki animacyjne gracza i przeciwnikw odwrcone w lewo

ShowTitleScreen                           ; wywietl ekran tytuowy 'TITLE.BMP'

         mvx #$FF newOpponent
         inx                              ; bardzo wane zerowanie zmiennych (pniej s one zerowane w SetPlayfield1/2)
         STX IsAnimateWaterfall           ; =0 nie animowa wodospadu na przerwaniu VBL
         STX IsSetPlayerVBL
         STX IsSetOpponentVBL
         STX IsSetWeaponVBL
         STX IsEnableArrow
         STX DrawBitmapY                  ; pozycja Y dla rysowanych obrazkw przez DrawBitmap
         stx OpponentPL1
         stx OpponentPL2

         LDX #7                            ; pocztek gry, maksymalna liczba y!
SetLife1 LDA #%11111000                    ; 5 y
         STA Bar03pl1,X                    ; pasek z ycia dla player'a 1 (przepisywane na PMG)
         STA Bar03pl2,X                    ; pasek z ycia dla player'a 2 (przepisywane na PMG)
         DEX
         BPL SetLife1

         mwa #Bar03pl1        AddrBar03          ; aktualny pasek z yciami gracza (AddrBar03-->na ekran)
         mwa ScorePlayer1     ScorePlayer        ; aktualny wynik punktowy gracza w kodzie BCD(ScorePlayer-->na ekran)
         mwa ScorePlayer1Last ScorePlayerLast    ; ostatni wynik punktowy gracza w kodzie BCD (ScorePlayerLast-->na ekran)
         mva #1               ActivePlayer       ; aktualnie gra gracz nr.1 (ActivePlayer-->na ekran)
         mva OpponentPl1      Opponent           ; pierwszy przeciwnik! Buchu (Opponent-->nazwa przeciwnika-->na ekran)
         LDY #<:YieMusicFX3
         LDX #>:YieMusicFX3
         JSR InitMPT                      ; inicjuj player MPT i graj muzyk tytuow

         LDX #TitleMusic
         JSR PlaySongMPT

loopTitl ScreenOFF                        ; wycz wywietlanie PMG i ekranu

         MWA #PlayfieldVBL VVBLKI         ; ustaw przerw. VBL

         copy_DLI :DLITitleCopy,:DLITitle.len
         MWA #memory_reserved_for_DLI VDSLST  ; ustaw przerw. DLI

         MWA #DListTitle   SDLSTL         ; ustaw program dla ANTIC-a (Display List)

         MVA #>[Screen160x200Buffor2+$0400] Index1  ; uyw. w przerw. DLI dla wskazania, ktry zestaw znakw w wier. ma by ustawiony

         @BANK_JSR :InitScreen2           ; tworzy specjalny tryb na ekranie 40x25 znakw + zmiana zestawu znakw co 3 wiersze

         JSR SetClearPMG                  ; wyczy pami PMG oraz wycz rejetry zwizane z grafik PMG

         LDA @TAB_MEM_BANKS+1             ; narysuj ekran tytuowy (TITLE.BMP) na 2-gim buforze ekranowym
         STA PORTB
         LDA #25
         LDX #<:Title
         LDY #>:Title
;dupa
         JSR DrawBitmapOnScreenBuffor2

         @BANK_JSR :DrawFifthColorOnTitleScreenBank ; ustaw w odpow. znakach na ekranie bit7, eby uzyska 5-ty kolor
         @BANK_JSR :SetColorsTitleScreenBank        ; ustaw odpowiednie kolory
         @BANK_JSR :SetPMGOnTitleScreenBank         ; ustaw graf. PMG jako podkad (dla uzykania wikszej liczby kolorw)

         ScreenON                        ; wcz wywietlanie PMG i ekranu

         TestFireAndWait                 ; czekaj 10sekund i w tym czasie sprawdzaj czy nacinito FIRE?
                                         ; jeeli nacinito to skacz do 'ShowPlayersScreen' - ekran wyboru 1 lub 2 graczy

         JSR ShowScoreScreen             ; wywietl ekran z list graczy i punktami

         TestFireAndWait

         JMP loopTitl

TestFireAndWait .PROC
         ldy #10

LoopT00  LDX #50
LoopT01  LDA Trig0   ;Sprawdzanie czy nacinieto FIRE?
         sne
         jmp ShowPlayersScreen
         LDA VCOUNT
         BNE LoopT01

         STA WSYNC
         DEX
         BNE LoopT01

         dey
         BNE LoopT00

         RTS
.ENDP
;------------------------------------------------------------------------------------------------------------------------
ShowScoreScreen                           ; wycz wywietlanie PMG i ekranu
         ScreenOFF

         copy_DLI :DLIScoreCopy,:DLIScore.len
         MWA #memory_reserved_for_DLI VDSLST  ; ustaw przerw. DLI
         MWA #DListScore       SDLSTL         ; ustaw program dla ANTIC-a (Display List)

         JSR SetClearPMG                  ; wyczy pami PMG oraz wycz rejetry zwizane z grafik PMG

         JSR ShowScoreText                   ; wypisz nazwy graczy + ich wyniki punktowe
         @BANK_JSR :RefreshCoverColumnBank   ; aktualizuje dopenienie ostatniej kolumny na ScoreScreen
         @BANK_JSR :SetPMGOnScoreScreenBank  ; ustawienie grafiki PMG dla uzyskania wikszej liczby kolorw

         @BANK_JSR :WriteCharsOnScreen40x25Bank ;wstawia na samym dole od 21-wiersza 120 znakw, ktre s zamazywane. prawd. przez ShowScoreText

         LDA @TAB_MEM_BANKS+16               ; rysuje napis u gry ekranu 'RANK SCORE STAGE NAME'
         STA PORTB
         LDX #<:Score1
         LDY #>:Score1
         LDA #3
         JSR DrawBitmapOnScreenBuffor2

         LDA #3                              ; rysuje napis na dole ekranu 'YIE AR KUNG-FU' 'ATARI XL/XE VERSION'
         STA DrawBitmapY
SS01     LDX #<:Score2
SS02     LDY #>:Score2
         LDA #3
         JSR DrawBitmapOnScreenBuffor2

         @BANK_JSR :SetColorsSTAGEBank      ; ustawia kolory

  ;       MVA #%00111110 SDMCTL              ; wcz wywietlanie PMG i ekranu
         ScreenON

         RTS
;------------------------------------------------------------------------------------------------------------------------
COLPF0sel .byte 0
COLPF1sel .byte 0
COLPF2sel .byte 0
COLPF3sel .byte 0
SetColorsPL1        ; ustawia podwietlony napis 'One Player' na to
         mva #1*16+2 COLPF0sel
         mva #0*16+6 COLPF1sel
         mva #1*16+6 COLPF2sel
         mva #0*16+2 COLPF3sel
         mva #1 OneTwoPlayer
         jmp SELPL1

SetColorsPL2       ; ustawia podwietlony napis 'Two Players' na to
         mva #0*16+6 COLPF0sel
         mva #1*16+6 COLPF1sel
         mva #0*16+2 COLPF2sel
         mva #1*16+2 COLPF3sel
         mva #2 OneTwoPlayer
         jmp SELPL1

ShowPlayersScreen                         ; tworzy ekran wyboru na ilu graczy bdziemy gra?
         ScreenOFF                        ; wycz wywietlanie PMG i ekranu

         JSR SetClearPMG                  ; wyczy pami PMG oraz wycz rejetry zwizane z grafik PMG

         LDA #0                           ; zerowanie zmiennych
         STA IsAnimateWaterfall
         STA ScorePlayer1
         STA ScorePlayer1+1
         STA ScorePlayer2
         STA ScorePlayer2+1
         STA ScorePlayer1Last
         STA ScorePlayer1Last+1
         STA ScorePlayer2Last
         STA ScorePlayer2Last+1
         STA OpponentPl1
         STA OpponentPl2

         copy_DLI :DLIPlayersCopy,:DLIPlayers.len
         MWA #memory_reserved_for_DLI VDSLST  ; ustaw przerw. DLI
         MWA #DListPlayers SDLSTL             ; ustaw program dla ANTIC-a (Display List)

         @BANK_JSR :InitScreen2           ; tworzy specjalny tryb na ekranie 40x25 znakw + zmiana zestawu znakw co 3 wiersze

         mva #1 ChangeScreenBuffor
         JSR SetAddrCharsetsTAB           ; ustawia tablice 'AddrCharsetsTAB' - kolejne starsze adresy zestaww znakw zmieniane co 3 wiersze w przerw. DLI

         LDA @TAB_MEM_BANKS+1             ; rysuje obrazek 'PLAYERS.BMP' na ekranie
         STA PORTB
         LDA #25
         LDX #<:Players
         LDY #>:Players
         JSR DrawBitmapOnScreenBuffor2

         @BANK_JSR :DrawFifthColorOnPlayersScreenBank  ; ustawia bit7 w znakach na ekranie dla uzyskania 5-tego koloru

         mva #8*16+2  COLOR1                ; ustawiamy kolory
         mva #8*16+6  COLOR2
         mva #1*16+10 COLOR0
         mva #0*16+6  COLOR3

         ScreenON

         JSR SetColorsPL1                  ; ustawia kolory i zmienna z liczb graczy(=1)
         bne SELPL2                        ; jmp bo Z=0 !

SELPL1   LDA PORTA                         ; wybr na ilu graczy bdzie gra? (1 czy 2 graczy)
         AND #15
         CMP #11
         JEQ SetColorsPL1
         CMP #7
         JEQ SetColorsPL2
SELPL2   LDA Trig0
         BNE SELPL1

;------------------------------------------------------------------------------------------------------------------------
ShowFirstDoors
         mva #0  IsAnimateWaterfall  ; ustawienie zmiennej informujcej, e nie naley animowa wodospadu
         mva #20 CounterBlinkPlayer  ; co ile jedn.(1/50s) ma miga cyfra 1(2) (napis na ekranie: PLAYER-1)

         lda ActivePlayer            ; zaktualizuj liczb punktw dla aktywnego wanie gracza!
         asl @
         tax
         mwa ScorePlayer ScorePlayer1-2,x

         LDY #0
         LDA (AddrBar03),Y           ; sprawd czy pasek ycia gracza jest pusty? (zero y?)
         BNE ShowFirstDoors2

         JSR ShowEndScreen

         JSR ShowGetNameScreen       ; przegrae niestety!
         JMP ShowTitleScreen

ShowFirstDoors2
         lda newOpponent
         cmp #$FF
         beq ShowFirstDoors2_

         mva newOpponent Opponent    ; ustaw odpowiedniego przeciwnika...tylko do testw...w normalnej grze bdzie usunite to
         mva #$FF newOpponent

ShowFirstDoors2_
         LDY #<:YieMusicFX
         LDX #>:YieMusicFX
         JSR InitMPT                 ; inicjuj player MPT

         LDA Opponent                ; sprawd czy pokonano wszystkich przeciwnikw?
         CMP #blue+2
         BNE ShowFirstDoors3

         JSR ShowWinnerScreen
         JSR ShowGetNameScreen       ; wygrae!
         JMP ShowTitleScreen

;------------------------------------------------------------------------------------------------------------------------
; poka 1-szy ekran z drzwiami i animacj przeciwnika
ShowFirstDoors3
         CMP #club
         JCS ShowSecondDoors

         ScreenOFF                       ; wycz ekran i PMG

         copy_DLI :DLIDoorBankCopy,:DLIDoorBank.len

         LDX #<memory_reserved_for_DLI   ; tworzy ekran w odpowiednim trybie
         LDY #>memory_reserved_for_DLI
         @BANK_JSR :SetDoorBank

         JSR SetClearPMG                 ; wyczy pami PMG oraz wycz rejetry zwizane z grafik PMG
         @BANK_JSR :SetColorsDoorsBank   ; ustaw kolory

         JSR CreateUpperTextOnScreenNew  ; tworzy grny tekst wraz z paskami energii i ycia
         JSR CreateHistoryText           ; wywietla napis 'HOT FIGHTING HISTORY' 'NEXT OPPONENT'
         JSR CreateDoor1Text             ; wywietla napisy kolejnych przeciwnikw 'Buchu Star Nuncha itd.'
         JSR LightUpText1                ; podwietla tekst(HIRES) grafik PMG na ekranie
         JSR PrintOpponentName           ; wypisuje nazw z jakim aktualnie bdziemy walczy przeciwnikiem

         @BANK_JSR :ShowDoors1Bank       ; rozrysowuje drzwi na ekranie (5 sztuk)

         LDX #DoorMusic                  ; graj muzyk dla ekranu z drzwiami
         JSR PlaySongMPT
         mva #1 IsPlayMusic

         JSR AnimateOpponent             ; animuj przeciwnika przez kilka sekund

         JMP ShowStageScreen

;------------------------------------------------------------------------------------------------------------------------
; poka 2-gi ekran z drzwiami i animacj przeciwnika
ShowSecondDoors
         ScreenOFF                       ; wycz ekran i PMG

         copy_DLI :DLIDoorBankCopy,:DLIDoorBank.len

         LDX #<memory_reserved_for_DLI   ; tworzy ekran w odpowiednim trybie
         LDY #>memory_reserved_for_DLI
         @BANK_JSR :SetDoorBank

         JSR SetClearPMG                 ; wyczy pami PMG oraz wycz rejetry zwizane z grafik PMG
         @BANK_JSR :SetColorsDoorsBank   ; ustaw kolory

         JSR CreateUpperTextOnScreenNew  ; tworzy grny tekst wraz z paskami energii i ycia
         JSR CreateHistoryText           ; wywietla napis 'HOT FIGHTING HISTORY' 'NEXT OPPONENT'
         JSR CreateDoor2Text             ; wywietla napisy kolejnych przeciwnikw 'Club Fan Sword itd.'
         JSR LightUpText2                ; podwietla tekst(HIRES) grafik PMG na ekranie
         JSR PrintOpponentName           ; wypisuje nazw z jakim aktualnie bdziemy walczy przeciwnikiem

         @BANK_JSR :ShowDoors2Bank       ; rozrysowuje drzwi na ekranie (5 sztuk)

         LDX #DoorMusic                  ; graj muzyk dla ekranu z drzwiami
         JSR PlaySongMPT
         mva #1 IsPlayMusic

         JSR AnimateOpponent             ; animuj przeciwnika przez kilka sekund

;------------------------------------------------------------------------------------------------------------------------
; poka ekran STAGE
ShowStageScreen
         ScreenOFF

         copy_DLI :DLIStageBankCopy,:DLIStageBank.len

         LDX #<memory_reserved_for_DLI   ; tworzy ekran w odpowiednim trybie
         LDY #>memory_reserved_for_DLI
         @BANK_JSR :SetStageBank

         JSR SetClearPMG             ; wyczy pami PMG oraz wycz rejetry zwizane z grafik PMG
         JSR ClearTextScreen         ; czyci ekran tekstowy 48x25

         @BANK_JSR :SetColorsSTAGEBank   ; ustaw odpowiednie kolory

         JSR CreateUpperTextOnScreenNew  ; tworzy grny tekst wraz z paskami energii i ycia

         LDA @TAB_MEM_BANKS+8            ; ustaw w Text4 numer 'STAGE xx'
         STA PORTB

         LDA #1+16
         STA :Text4+6
         LDA #0+16
         STA :Text4+7

         lda Opponent
         lsr @
         CMP #9
         BEQ ShStage1
         add #16+1
         sta :Text4+7
         lda #0+16
         sta :Text4+6

ShStage1 LDX #<10*48+20   ; wypisz tekst 'Player 1'
         LDY #>10*48+20
         LDA #34 ;Text18
         JSR PrintText
         LDA ActivePlayer
         CLC
         ADC #16
         STA Screen48x25+10*48+27

         LDX #<13*48+20   ; wypisz tekst 'STAGE 01'
         LDY #>13*48+20
         LDA #1
         JSR PrintText

         JSR PrintOpponentName                ; wypisuje nazw z jakim aktualnie bdziemy walczy przeciwnikiem

         ScreenON

         JSR ControlBehaviorPlayerSettings    ; ustaw zmienne dla proc. obsug. zachowanie gracza
         JSR ControlBehaviorOpponentSettings  ; ustaw zmienne dla proc. obsug. zachowanie przeciwnika
         JSR ControlBehaviorWeaponSettings    ; ustaw zmienne dla proc. obsug. zachowanie broni

         ldx Opponent                         ; skocz do odpowiedniego ekranu!
         mwa SkipToPlayfieldTAB,X address1
         jmp (address1)

;------------------------------------------------------------------------------------------------------------------------
ShowFirstPlayfieldScreen                       ; poka pierwszy ekran walki
         ScreenOFF

         ldx #0                                ; ustawienie zmiennych niezbdnych dla animacji wodospadu
         stx CounterWaterfallData
         INX
         STX IsEnableArrow
         STX CounterWaterfall
         STX IsAnimateWaterfall                ; ustawienie zmiennej informujcej, e naley animowa wodospad

         jsr SetClearPMG                       ; wyczy pami PMG oraz wycz rejetry zwizane z grafik PMG

         copy_DLI :DLIFirstCopy,:DLIFirst.len

         LDX #<memory_reserved_for_DLI         ; tworzy ekran w odpowiednim trybie
         LDY #>memory_reserved_for_DLI
         jsr SetPlayfield1

         LDA #StandardMemory                   ; rysuj plansz - 'Play01.BMP'
         STA PORTB
         LDA #3
         STA DrawBitmapY
         LDA #16
         LDX #<Play01
         LDY #>Play01
         JSR DrawBitmapOnScreenBuffors

         JSR DrawFifthColorOnFirstScreen           ; ustaw bit7 w odpowiednich znakach na ekranie (dodatkowy 5-ty kolor)
         @BANK_JSR :SetColorsForFirstPlayfieldBank ; ustaw kolory

         JSR PrintOpponentName                 ; wypisuje nazw z jakim aktualnie bdziemy walczy przeciwnikiem
         ldx #<:PlayerBitmapRight1             ; narysuj gracza na ekranie
         ldy #>:PlayerBitmapRight1
         jsr ShowPlayer

         ScreenON

         LDX #FirstMusic                       ; graj muzyk dla pierwszego ekranu walki
         JSR PlaySongMPT
         mva #1 IsPlayMusic

         JSR ControlBehaviorPlayerAndOpponent  ; gwna procedura animacyjna dla gracza i przeciwnika
         JMP ShowFirstDoors                    ; skok do ekranu z drzwiami

;------------------------------------------------------------------------------------------------------------------------
ShowSecondPlayfieldScreen                      ; poka drugi ekran walki
         ScreenOFF

         mva #0 IsAnimateWaterfall             ; ustawienie zmiennej informujcej, e nie naley animowa wodospadu
         mva #1 IsEnableArrow

         JSR SetClearPMG                       ; wyczy pami PMG oraz wycz rejetry zwizane z grafik PMG

         copy_DLI :DLISecondCopy,:DLISecond.len

         LDX #<memory_reserved_for_DLI         ; tworzy ekran w odpowiednim trybie
         LDY #>memory_reserved_for_DLI
         JSR SetPlayfield2

         LDA #StandardMemory                   ; rysuj plansz - 'Play02.BMP'
         STA PORTB
         LDA #3
         STA DrawBitmapY
         LDA #16
         LDX #<Play02
         LDY #>Play02
         JSR DrawBitmapOnScreenBuffors

         JSR DrawFifthColorOnSecondScreen           ; ustaw bit7 w odpowiednich znakach na ekranie (dodatkowy 5-ty kolor)
         @BANK_JSR :SetColorsForSecondPlayfieldBank ; ustaw kolory

         JSR PrintOpponentName                 ; wypisuje nazw z jakim aktualnie bdziemy walczy przeciwnikiem

         ldx #<:PlayerBitmapRight1             ; narysuj gracza na ekranie
         ldy #>:PlayerBitmapRight1
         jsr ShowPlayer

         ScreenON

         LDX #SecondMusic                      ; graj muzyk dla pierwszego ekranu walki
         JSR PlaySongMPT
         mva #1 IsPlayMusic

         JSR ControlBehaviorPlayerAndOpponent  ; gwna procedura animacyjna dla gracza i przeciwnika
         JMP ShowFirstDoors                    ; skok do ekranu z drzwiami

;------------------------------------------------------------------------------------------------------------------------
ShowThirdPlayfieldScreen                       ; poka trzeci ekran walki
         ScreenOFF

         mva #0 IsAnimateWaterfall             ; ustawienie zmiennej informujcej, e nie naley animowa wodospadu
         mva #1 IsEnableArrow

         JSR SetClearPMG                       ; wyczy pami PMG oraz wycz rejetry zwizane z grafik PMG

         copy_DLI :DLIThirdCopy,:DLIThird.len

         LDX #<memory_reserved_for_DLI         ; tworzy ekran w odpowiednim trybie
         LDY #>memory_reserved_for_DLI
         JSR SetPlayfield1

         LDA #StandardMemory                   ; rysuj plansz - 'Play03.BMP'
         STA PORTB
         LDA #3
         STA DrawBitmapY
         LDA #16
         LDX #<Play03
         LDY #>Play03
         JSR DrawBitmapOnScreenBuffors

         @BANK_JSR :SetColorsForThirdPlayfieldBank ; ustaw kolory

         JSR PrintOpponentName                     ; wypisuje nazw z jakim aktualnie bdziemy walczy przeciwnikiem

         ldx #<:PlayerBitmapRight1             ; narysuj gracza na ekranie
         ldy #>:PlayerBitmapRight1
         jsr ShowPlayer

         ScreenON

         LDX #SecondMusic                      ; graj muzyk dla pierwszego ekranu walki
         JSR PlaySongMPT
         mva #1 IsPlayMusic

         JSR ControlBehaviorPlayerAndOpponent  ; gwna procedura animacyjna dla gracza i przeciwnika
         JMP ShowFirstDoors                    ; skok do ekranu z drzwiami

;---------------------------------------------
CheckOneorTwoPlayers
         LDA PORTB
         PHA
         LDA Banks+7
         STA PORTB
         JSR :CheckOneorTwoPlayersBank
         PLA
         STA PORTB
         RTS

;------------------------------------------------------------------------------------------------------------------------
ShowGetNameScreen         ; poka ekran z moliwoci wpisania nazwy gracza
         ScreenOFF

         LDY #<:YieMusicFX
         LDX #>:YieMusicFX
         JSR InitMPT      ; odtwarzaj muzyk

         LDX #GetNameMusic
         JSR PlaySongMPT

         LDA @TAB_MEM_BANKS+8
         STA PORTB

         mva #4*16+6  PCOLR3       ; ustaw kolory
         mva #3*16+6  PCOLR0
         mva #8*16+6  PCOLR1
         mva #12*16+6 PCOLR2

         mva #0 IsAnimateWaterfall ; ustawienie zmiennej informujcej, e nie naley animowa wodospadu

         LDX ScorePlayer1
         LDY ScorePlayer1+1
         JSR :ShowGetNameScreenBank
         BCS ShGet01
         LDX #<:ScorePL1 ; Please write your name, Player 1
         LDY #>:ScorePL1
         STX SS01+1
         STY SS02+1
         JSR ShowScoreScreen
         LDX #<:Score2   ; Yie Ar Kung-Fu, ATARI XL/XE version
         LDY #>:Score2
         STX SS01+1
         STY SS02+1
         JSR GetName
         ScreenOFF

ShGet01  LDA OneTwoPlayer
         CMP #2
         BNE ShowGetNameScreen2

         LDX ScorePlayer2
         LDY ScorePlayer2+1
         JSR :ShowGetNameScreenBank
         BCS ShowGetNameScreen2
         LDX #<:ScorePL2 ; Please write your name, Player 2
         LDY #>:ScorePL2
         STX SS01+1
         STY SS02+1
         JSR ShowScoreScreen
         LDX #<:Score2   ; Yie Ar Kung-Fu, ATARI XL/XE version
         LDY #>:Score2
         STX SS01+1
         STY SS02+1
         JSR GetName

ShowGetNameScreen2
         ScreenOFF
         RTS
;---------------------------------------------
GetName  LDY #32         ; pobierz nazw wpisywan z klawiatury
LoopWriteChars
         STY BlinkY
         CPY #38
         BEQ SkipWriteChars2 ;wpisano wszystkie litery!

         LDA #20
         STA CounterBlinkCursor
         LDA #1
         STA IsBlinkCursor
         JSR WaitKey ;Blink
         LDA #0
         STA IsBlinkCursor

         LDA CH
         JSR ConvertKeyToATASCII

         CMP #$7E ;BACKSPACE
         BEQ UndoWriteChar
         CMP #155
         BEQ SkipWriteChars1
         CMP #97
         SCS
         JMP LoopWriteChars
         CMP #122+1
         BCS LoopWriteChars ;JMP
         JMP WriteChar

SkipWriteChars1
         LDA #0
LoopChar01
         STA (address7),Y
         STA (address8),Y
         INY
         CPY #38
         BNE LoopChar01

SkipWriteChars2
         RTS
;--------------------------
WriteChar
         SEC
         SBC #32  ;zamie na due litery
WriteCharSpace
         SEC
         SBC #32  ;zamie na kod wewntrzny
         STA (address7),Y
         STA (address8),Y
         INY
         JMP LoopWriteChars
UndoWriteChar
         LDA #63 ;_
         CPY #31
         BCC LoopWriteChars
         STA (address7),Y
         STA (address8),Y
         DEY
         STA (address7),Y
         STA (address8),Y
         JMP LoopWriteChars
;------------------------------------------
; Uproszczona procka konwertujca znaki kodw klawiatury na kody ATASCII
ConvertKeyToATASCII
         AND #255-128-64 ; kasuj SHIFT+CONTROL
         TAX
         LDA Banks+7
         STA PORTB
         LDA :KeyToATASCIITAB,X
         RTS

;------------------------------------------------------------------------------------------------------------------------
ShowWinnerScreen
         ScreenOFF

         mva #0 IsAnimateWaterfall ; ustawienie zmiennej informujcej, e nie naley animowa wodospadu

         JSR UpdateHiScorePlayer   ; aktualizuje najwyszy wynik jeeli zosta przekroczony prze gracza 1 lub 2

         copy_DLI :DLIWinnerCopy,:DLIWinner.len

         LDX #<memory_reserved_for_DLI         ; tworzy ekran w odpowiednim trybie
         LDY #>memory_reserved_for_DLI
         @BANK_JSR :SetWinnerScreen

         JSR SetClearPMG           ; wyczy pami PMG oraz wycz rejetry zwizane z grafik PMG

         LDA @TAB_MEM_BANKS+16     ; rysuj plansze zwycistwa - 'WINNER.BMP'
         STA PORTB
         LDX #<:Winner
         LDY #>:Winner
         LDA #24
         JSR DrawBitmapOnScreenBuffor2

         @BANK_JSR :SetColorsWinnerScreenBank ; ustaw kolory

         LDX #WinnerMusic          ; odtworzenie muzyki
         JSR PlaySongMPT

         mva #4 Index1             ; uywane przez przerwanie DLI - wskazuje na aktualny zestaw CHARSET

         ScreenON

_LOP	 lda trig0                 ; sprawdzanie czy nacinieto FIRE w joy 1 lub 2?
         and trig1
         bne _LOP

         ScreenOFF
         rts

;----------------------------------------------------------------------------------------------------------------------
UpdateHiScorePlayer
         ;Aktualizacja Hi-Score dla ScorePlayer1
         LDA HiScorePlayer+1
         CMP ScorePlayer1+1
         SEQ
         BCS SkipHi1
         LDA HiScorePlayer
         CMP ScorePlayer1
         BCS SkipHi1

         LDA ScorePlayer1
         STA HiScorePlayer
         LDA ScorePlayer1+1
         STA HiScorePlayer+1
SkipHi1
         ;Aktualizacja Hi-Score dla ScorePlayer2
         LDA HiScorePlayer+1
         CMP ScorePlayer2+1
         SEQ 
         BCS SkipHi2
         LDA HiScorePlayer
         CMP ScorePlayer2
         BCS SkipHi2

         LDA ScorePlayer2
         STA HiScorePlayer
         LDA ScorePlayer2+1
         STA HiScorePlayer+1

SkipHi2  RTS

;----------------------------------------------------------------------------------------------------------------------
ShowEndScreen
         ScreenOFF

         mva #0 IsAnimateWaterfall ; ustawienie zmiennej informujcej, e nie naley animowa wodospadu

         LDX #EndMusic             ; odtworzenie muzyki
         JSR PlaySongMPT

         JSR UpdateHiScorePlayer   ; aktualizuje najwyszy wynik jeeli zosta przekroczony prze gracza 1 lub 2

         copy_DLI :DLIEndCopy,:DLIEnd.len

         LDX #<memory_reserved_for_DLI         ; tworzy ekran w odpowiednim trybie
         LDY #>memory_reserved_for_DLI
         @BANK_JSR :SetEndScreen

         JSR SetClearPMG           ; wyczy pami PMG oraz wycz rejetry zwizane z grafik PMG

         LDA @TAB_MEM_BANKS+15     ; rysuj plansze kocow - 'END1.BMP' + 'END2.BMP'
         STA PORTB
         LDA #4
         STA DrawBitmapY
         LDX #<:End
         LDY #>:End
         LDA #16
         JSR DrawBitmapOnScreenBuffor2

         @BANK_JSR :SetColorsEndScreenBank ; ustaw kolory

         mva #4 Index1             ; uywane przez przerwanie DLI - wskazuje na aktualny zestaw CHARSET

         ScreenON

_LOP2	 lda trig0                 ; sprawdzanie czy nacinieto FIRE w joy 1 lub 2?
         and trig1
         bne _LOP2

         ScreenOFF
         rts

;--------------------------------------------------------------
CounterWaterfall     .byte 0
CounterWaterfallData .byte 0
;--------------------------------------------------------------
SkipToPlayfieldTAB
 .word ShowFirstPlayfieldScreen,ShowFirstPlayfieldScreen,ShowFirstPlayfieldScreen
 .word ShowSecondPlayfieldScreen,ShowSecondPlayfieldScreen,ShowSecondPlayfieldScreen
 .word ShowThirdPlayfieldScreen,ShowThirdPlayfieldScreen,ShowThirdPlayfieldScreen,ShowThirdPlayfieldScreen

IsFullBuffor         .BYTE 0   ; 0 i 1 nie odtwarza ta, ale ju dla 2 odtwarza to pod broni
IsThrowWeapon        .BYTE 0   ; Czy rzucono broni? 1=TAK
IsEndAnimationWeapon .BYTE 0   ; rwne 3,2 i 1 naley zakoczy animacj, wywietli jedynie bufory ta
                               ; nie wywietla ju Weapon na nowej pozycji
ControlBehaviorWeaponSettings
         LDX #0
         STX IsWeaponFaceOnRight
         STX IsEndAnimationWeapon
         STX IsFullBuffor
         STX IsThrowWeapon
         INX
         STX IsFirstCallWeapon
         LDA PORTB
         PHA
         LDX #1
         LDA Opponent
         CMP #Fan
         BNE ControlBehaviorWeaponSettings2
         INX
ControlBehaviorWeaponSettings2
         LDY Banks+9
         STY PORTB
         STX :ShowWeapon00c+1
         STX :ShowWeapon00e+1
         STX :ShowWeapon00f+1
         LDX #3
         CMP #Chain
         BNE ControlBehaviorWeaponSettings3
         LDA #<:SizeOfWeapon+16
         STA :ShowWA+1
         LDA #>:SizeOfWeapon+16
         STA :ShowWB+1
         INX                                ;4 znaki dla CHAIN
         STX :ShowWeapon01+1
         PLA
         STA PORTB
         RTS

ControlBehaviorWeaponSettings3
         STX :ShowWeapon01+1
         LDA #<:SizeOfWeapon
         STA :ShowWA+1
         LDA #>:SizeOfWeapon
         STA :ShowWB+1
         PLA
         STA PORTB
         RTS
;------------------------------------------------------------------------
IsBlinkCursor      .byte 0 ;Czy migac kursorem na ScoreScreen?
CounterBlinkCursor .byte 0
BlinkY             .byte 0

IsImmortal .byte 0       ;=1 wczona niemiertelno

tab_keyboard .byte 31,30,26,24,29,27,51,53,48,50
tab_keyopp   .byte buchu,star,nuncha,pole,chain,club,fan,sword,tonfun,blue
newOpponent  .byte $FF
PlayfieldVBL
         LDA PORTB
         PHA

         ldx #9
         lda CH1        ; Sprawd czy wczy/wyczy niemiertelno? w kocowej grze to usun!
loop_fi0 cmp tab_keyboard,x
         bne PlayVB00

         mva tab_keyopp,x newOpponent
         mva #255 CH1

PlayVB00 dex
         bpl loop_fi0

         LDA CH1        ; Sprawd czy wczy/wyczy niemiertelno? w kocowej grze to usun!
         CMP #47        ; klawisz Q - wcz
         BNE PlayVB01

         LDA #1
         STA IsImmortal
         LDA #255
         STA CH1

PlayVB01 CMP #46        ; klawisz W - wycz
         BNE PlayVB02

         LDA #0
         STA IsImmortal
         LDA #255
         STA CH1

PlayVB02 lda IsPlayOnVBL_FX ; Czy odgrywa FX-a na VBL-u?
         beq PlayVBLB

         dec CounterFX
         bne PlayVBLB

         lda CounterFXs
         sta CounterFX

         LDA #$01
         LDY NoteFX
         LDX #turn_pole_FX+$03*$40   ;rwnie dla turn_nuncha_FX
         @BANK_JSR :PlayerMPTBank

PlayVBLB LDA IsPlayMusic
         BEQ PlayVBL0

         LDA BANKS+1
         STA PORTB
         JSR :PlayMPTBank        ; graj muzyk

PlayVBL0 LDA IsAnimateWaterfall  ;czy animowa wodospad?
         BEQ PlayVBL1
         LDA BANKS+7
         STA PORTB
         JSR :DrawWaterfallBank

PlayVBL1 LDA IsSetPlayerVBL
         BEQ PlayVBL2

         mva #0 IsSetPlayerVBL
         JSR ShowPlayerContinueVBL

PlayVBL2 LDA IsBlinkCursor
         BEQ PlayVBL3
         LDA CounterBlinkCursor
         BNE PlayVBLA
         LDA #21
         STA CounterBlinkCursor
         LDY BlinkY
         LDA (address8),Y
         EOR #128
         STA (address8),Y
PlayVBLA DEC CounterBlinkCursor

PlayVBL3 LDA IsEnableArrow
         BEQ PlayVBL4
         JSR ShowArrow

PlayVBL4 LDA #0
         STA IsSetOpponentVBL
         STA IsSetWeaponVBL
         STA IsVBLDid

         PLA
         STA PORTB

         RTS
;-------------------------------------------------------
ShowWeapon
        LDA PORTB
        PHA
        LDA Banks+9
        STA PORTB
        JSR :ShowWeaponBank
        PLA
        STA PORTB
        RTS
;-------------------------------------------------------
DeadPlayer
        LDA IsEnd  ;Zabito ju gracza lub przeciwnika!
        SEQ
        RTS
        LDA PORTB
        PHA
        LDX #DeadPlayerMusic
        JSR PlaySongMPT
        LDA Banks+9
        STA PORTB
        JSR :DeadPlayerBank
        PLA
        STA PORTB
        RTS
;-------------------------------------------------------
ShowWeaponLast
        LDA PORTB
        PHA
        LDA Banks+9
        STA PORTB
        JSR :ShowWeaponLastBank
        PLA
        STA PORTB
        RTS
;-------------------------------------------------------
AnimateOpponent
        LDA PORTB
        PHA
        LDA Banks+7
        STA PORTB
        JSR :AnimateOpponentBank
        PLA
        STA PORTB
        RTS
;-------------------------------------------------------
LightUpText1
        LDA PORTB
        PHA
        LDA Banks+7
        STA PORTB
        JSR :LightUpTextBank1
        PLA
        STA PORTB
        RTS
;-------------------------------------------------------
LightUpText2
        LDA PORTB
        PHA
        LDA Banks+7
        STA PORTB
        JSR :LightUpTextBank2
        PLA
        STA PORTB
        RTS
;-------------------------------------------------------
ClearTextScreen
         LDA #<Screen48x25
         STA adr_scr
         LDA #>Screen48x25
         STA adr_scr+1

         FillMemory #Screen48x25,#25*48,#$00  ;czycimy ekran
         RTS
;-------------------------------------------------------
CreateDoor1Text
         LDA #3
         LDX #<12*48
         LDY #>12*48
         JSR PrintText
         LDA #4
         LDX #<22*48
         LDY #>22*48
         JMP PrintText
CreateDoor2Text
         LDA #5
         LDX #<12*48
         LDY #>12*48
         JSR PrintText
         LDA #6
         LDX #<22*48
         LDY #>22*48
         JMP PrintText

CreateHistoryText
         LDA #2
         LDX #<3*48
         LDY #>3*48
PrintText
        PHA
        LDA PORTB
        STA StorePrint
        LDA BANKS+7
        STA PORTB
        PLA
        JSR :PrintTextBank
        LDA StorePrint
        STA PORTB
        RTS
StorePrint .byte 0
;-------------------------------------------------------
DrawFifthColorOnSecondScreen
        LDA PORTB
        PHA
        LDA Banks+7
        STA PORTB
        JSR :DrawFifthColorOnSecondScreenBank
        PLA
        STA PORTB
        RTS

DrawFifthColorOnFirstScreen
        LDA PORTB
        PHA
        LDA Banks+7
        STA PORTB
        JSR :DrawFifthColorOnFirstScreenBank
        PLA
        STA PORTB
        RTS

SetPlayfield1
        LDA PORTB
        PHA
        LDA Banks+7
        STA PORTB
        JSR :SetPlayfield1Bank
        PLA
        STA PORTB
        RTS

SetPlayfield2
        LDA PORTB
        PHA
        LDA Banks+7
        STA PORTB
        JSR :SetPlayfield2Bank
        PLA
        STA PORTB
        RTS

ControlBehaviorPlayerSettings
         LDX #20+48
         LDY #156+24
         STX XCoordinatePlayer
         STX XOldCoordinatePlayer
         stx XOldCoordinatePlayer+1
         STY YCoordinatePlayer
         STY YOldCoordinatePlayer
         sty YOldCoordinatePlayer+1
         LDX #255
         STX HighHIT
         INX
         STX ChangeAddrPMBASE
         STX CounterPlayer
         INX
         STX IsPlayerFaceOnRight
         STX IsFirstCall
         INX
         STX PlayerBitmapBank
         LDX #<:PlayerBitmapRight1
         LDY #>:PlayerBitmapRight1
         JMP ShowPlayer

ControlBehaviorOpponentSettings
         LDX #100+48
         LDY #128+24  ;152
         STX XCoordinateOpponent
         STX XOldCoordinateOpponentTAB
         STX XOldCoordinateOpponentTAB+1
         STX XOldCoordinateOpponent
         STY YCoordinateOpponent
         STY YOldCoordinateOpponent
         STY YOldCoordinateOpponentTAB
         STY YOldCoordinateOpponentTAB+1
         LDA Opponent
         lsr @
         TAX
         LDA OpponentColorTAB,X
         STA OpponentColor
         LDX #255
         STX HighHITO
         INX
         STX IsOpponentFaceOnRight
         STX StoreIsOpponentFaceOnRight
         STX IsClearOpponent
         INX
         STX IsFirstCallOpponent
         JMP CreateOpponentSHIFTClips

; dodaj nazw na grze ekranu aktualnego przeciwnika
PrintOpponentName
         LDA Opponent
         lsr @
         CLC
         ADC #8 ;Text11
         LDX #<2*48+31+4
         LDY #>2*48+31+4
         JSR PrintText
         LDA Opponent
         lsr @
         ADC #18 ;Text12
         LDX #<27+4
         LDY #>27+4
         JMP PrintText
;---------------------------------------------------
NumberOpponentClipsTAB ;ile klatek przypada na kadego przeciwnika
 .byte :CounterBuchu,:CounterStar,:CounterNuncha,:CounterPole,:CounterChain
 .byte :CounterClub,:CounterFan,:CounterSword,:CounterTonfuna,:CounterBlue

; Tworzenie klatek przeciwnika przesunitych o -1,-2,-3,+1,+2,+3 punkty
; W czasie rzeczywistym przed wywietleniem ekranu walki
CreateOpponentSHIFTClips
         mva #0 Counter3

CreateS1 LDA Opponent
         lsr @
         TAX
         LDA IndexOpponentClipBank,X
         TAY
         LDA OpponentClipBank,Y
         STA OpponentBitmapBank      ;w ktrym banku jest pierwsza klatka

         LDA NumberOpponentClipsTAB,X
         STA Counter1                ;ile klatek przypada na danego przeciwnika?

         LDA AddrOpponentTABL,X       ; adres pierwszej rdowej klatki
         STA address4
         STA address6
         LDA AddrOpponentTABH,X
         STA address4+1
         STA address6+1

         LDX Counter3
         LDA #<$4000   ;poprawka likwidujca bd!
         STA address5
         STA address7
         LDA #>$4000
         STA address5+1
         STA address7+1

         LDA ASLOpponentClipTABL,X
         STA CreateC1+1
         STA CreattC1+1
         LDA ASLOpponentClipTABH,X
         STA CreateC1+2
         STA CreattC1+2
         LDA LSROpponentClipTABL,X
         STA CreateC2+1
         STA CreattC2+1
         LDA LSROpponentClipTABH,X
         STA CreateC2+2
         STA CreattC2+2

         LDA Banks+10,X
         STA DestBank

         JSR CreateSHIFT

         INC Counter3
         LDA Counter3
         CMP #4
         BNE CreateS1

         RTS
DestBank .byte 0

ASLOpponentClipTABL .BYTE <ASLOpponentClip0,<ASLOpponentClip1,<ASLOpponentClip2,<ASLOpponentClip3
ASLOpponentClipTABH .BYTE >ASLOpponentClip0,>ASLOpponentClip1,>ASLOpponentClip2,>ASLOpponentClip3
LSROpponentClipTABL .BYTE <LSROpponentClip0,<LSROpponentClip1,<LSROpponentClip2,<LSROpponentClip3
LSROpponentClipTABH .BYTE >LSROpponentClip0,>LSROpponentClip1,>LSROpponentClip2,>LSROpponentClip3

;--------------------------------------------
CreateSHIFT
         JSR CreateOpponentSHIFTClips1

         LDA address6
         add #<[2*size_frame8_opponent]+3 ;$303
         STA address4
         STA address6
         LDA address6+1
         ADC #>[2*size_frame9_opponent]+3 ;$303
         STA address4+1
         STA address6+1

         LDA address7
         add #<[2*size_frame9_opponent] ;$360+8
         STA address5
         STA address7
         LDA address7+1
         ADC #>[2*size_frame9_opponent] ;$360+8
         STA address5+1
         STA address7+1

         DEC Counter1
         BNE CreateSHIFT

         RTS
;------------------------------------
CreateOpponentSHIFTClips1
         LDA PORTB
         PHA

         LDX OpponentBitmapBank
         mva Banks+0,X Data1

         adw address5 #8 address8

; przesu klatki przeciwnika zwrconego w lewo
         mva #6 Counter2

CreateO0 mva #8*1 Counter4
         LDY #0

CreateO1 mvx Data1 PORTB

         lda (address4),y

         mvx #0 Data2
         mvx DestBank PORTB

CreateC1 JSR $FFFF ;ASLOpponentClip1

         STA (address8),Y
         mva Data2 (address5),Y+

         dec Counter4
         bne CreateO1
;---
         mva #8*7 Counter4

CreattO1 mvx Data1 PORTB

         LDA (address4),Y

         mvx #0 Data2
         mvx DestBank PORTB

CreattC1 JSR $FFFF ;ASLOpponentClip1

         STA (address8),Y
         LDA Data2
         add (address5),Y
         STA (address5),Y+

         DEC Counter4
         BNE CreattO1

         adw address4 #8*8
         adw address5 #9*8
         adw address8 #9*8

         dec Counter2
         jne CreateO0

; przesu klatki przeciwnika zwrconego w prawo
         adw address6 #size_frame8_opponent+2 address4
         adw address7 #size_frame9_opponent   address5
         adw address5 #8                      address8

         mva #6 Counter2

CreateP0 mva #8*1 Counter4
         LDY #0

CreateP1 mvx Data1 PORTB

         LDA (address4),Y
         mvx #0 Data2
         mvx DestBank PORTB

CreateC2 JSR $FFFF ;LSROpponentClip1

         STA (address5),Y
         mva Data2 (address8),Y+

         DEC Counter4
         BNE CreateP1

         mva #8*7 Counter4

CreattP1 mvx Data1 PORTB

         LDA (address4),Y

         mvx #0 Data2
         mvx DestBank PORTB

CreattC2 JSR $FFFF ;LSROpponentClip1

         add (address5),Y
         STA (address5),Y
         mva Data2 (address8),Y+

         DEC Counter4
         BNE CreattP1

         adw address4 #8*8
         adw address5 #9*8
         adw address8 #9*8

         dec Counter2
         jne CreateP0

         PLA
         STA PORTB

         RTS
;-----------------------
ASLOpponentClip0
         asl @
         ROL Data2
         asl @
         ROL Data2
ASLOpponentClip3
         asl @
         ROL Data2
         asl @
         ROL Data2
ASLOpponentClip2
         asl @
         ROL Data2
         asl @
         ROL Data2
ASLOpponentClip1
         asl @
         ROL Data2
         asl @
         ROL Data2
         RTS
;-----------------------
LSROpponentClip3
         lsr @
         ROR Data2
         lsr @
         ROR Data2
LSROpponentClip2
         lsr @
         ROR Data2
         lsr @
         ROR Data2
LSROpponentClip1
         lsr @
         ROR Data2
         lsr @
         ROR Data2
LSROpponentClip0
         RTS
;---------------------------------------------------
StoreYCoordinateOpponent   .byte 0
XOldCoordinateOpponent     .byte 0
YOldCoordinateOpponent     .byte 0
RepeatLoopOpponent         .byte 0 ;licznik wykorzystywany do ptli animacyjnej dla Przeciwnika
IsOpponentFaceOnRight      .byte 1 ;1 - YES
StoreIsOpponentFaceOnRight .byte 1 ;1 - YES
OpponentBitmapBank         .byte 2
IsDrawOpponent             .byte 0
;---------------------------------------------------
; Kolory kolejnych przeciwnikw
OpponentColorTAB
         .BYTE 120-2,$36-2,$FA-2,$C8-2,$66-2
         .BYTE $C6-2,$34-2,$06-2,$28-2,$96-2

AddrOpponentTABL                      ;Bank
         .BYTE <:BuchuClips  ;Buchu      3
L13B3    .BYTE <:StarClips   ;Star       3
         .BYTE <:NunchaClips ;Nuncha     4
         .BYTE <:PoleClips   ;Pole       4
         .BYTE <:ChainClips  ;Chain      5
         .BYTE <:ClubClips   ;Club       5
         .BYTE <:FanClips    ;Fan        5
         .BYTE <:SwordClips  ;Sword      6
         .BYTE <:TonfunaClips;Tonfuna    6
         .BYTE <:BlueClips   ;Blue       6
         .BYTE <:DelyClips   ;Dely       3

AddrOpponentTABH                      ;Bank
         .BYTE >:BuchuClips  ;Buchu      3
L13C9    .BYTE >:StarClips   ;Star       3
         .BYTE >:NunchaClips ;Nuncha     4
         .BYTE >:PoleClips   ;Pole       4
         .BYTE >:ChainClips  ;Chain      5
         .BYTE >:ClubClips   ;Club       5
         .BYTE >:FanClips    ;Fan        5
         .BYTE >:SwordClips  ;Sword      6
         .BYTE >:TonfunaClips;Tonfuna    6
         .BYTE >:BlueClips   ;Blue       6
         .BYTE >:DelyClips   ;Dely       3
;---------------------------------------------------
OpponentClipBank ; w ktrym Banku jest dana klatka z przeciwnikiem
 .BYTE 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3             ;15
 .BYTE 4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4   ;21
 .BYTE 5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5     ;19
 .BYTE 6,6,6,6,6,6,6,6,6,6,6,6                   ;12
 .BYTE 14,14,14,14,14,14,14,14,14                ;9
 .BYTE 3,3,3,3,3                                 ;5
 .BYTE 2                                         ;1

IndexOpponentClipBank
 .BYTE 0,:Index01,:Index02,:Index03,:Index04,:Index05,:Index06,:Index07,:Index08,:Index09,:Index10
;---------------------------------------------------
Add320OpponentTABL
 .BYTE <320,<320,<[320+64],<320,<320,<[320+64],<320,<320,<[320+64],<320,<320,<[320+64],<320,<320,<[320+64],<320,<320,<[320+64],<320,<320,<[320+64],<320,<320,<[320+64],<320
Add320OpponentTABH
 .BYTE >320,>320,>[320+64],>320,>320,>[320+64],>320,>320,>[320+64],>320,>320,>[320+64],>320,>320,>[320+64],>320,>320,>[320+64],>320,>320,>[320+64],>320,>320,>[320+64],>320
Add312OpponentTABL
 .BYTE <312,<312,<[312+64],<312,<312,<[312+64],<312,<312,<[312+64],<312,<312,<[312+64],<312,<312,<[312+64],<312,<312,<[312+64],<312,<312,<[312+64],<312,<312,<[312+64],<312
Add312OpponentTABH
 .BYTE >312,>312,>[312+64],>312,>312,>[312+64],>312,>312,>[312+64],>312,>312,>[312+64],>312,>312,>[312+64],>312,>312,>[312+64],>312,>312,>[312+64],>312,>312,>[312+64],>312

OpponentBitmapBankTAB
 .BYTE 10,13,12,11
 .BYTE 10,11,12,13

;----------------------------------------------------------------------
; Procedura wywietlajca przeciwnika na wsp. X/YCoordinateOpponent
;----------------------------------------------------------------------
ShowOpponentLast
         mwa AddrOpponentBitmap address4Opponent
         jmp ShowOpponent.ShowOpponent_

ShowOpponent .PROC (.WORD yx) .REG
         STX address4Opponent
         STY address4Opponent+1

ShowOpponent_
         mva #1 IsDrawOpponent

; Obliczenie adresu, w ktrym zostanie wywietlony przeciwnik i ustawienie adresu klatki
         LDA XCoordinateOpponent
         AND #3
         STA Data1Opponent

         LDA IsOpponentFaceOnRight
         :2 asl @    ;*4
         ADC Data1Opponent
         TAX

         mva OpponentBitmapBankTAB,x OpponentBitmapBank

ShowOp01 LDA IsOpponentFaceOnRight                       ;Jeeli Przeciwnik odwrcony w Prawo to dodaj do adresu klatki $01B0.
         BEQ ShowOp02

         adw address4Opponent #size_frame9_opponent

ShowOp02 lda :YCoordinateOpponent                        ;Oblicz adres startowy na ekranie dla wywietlenia przeciwnika
         sub #24
         tax
         mva :YCoordinateOpponentTABL,x address5Opponent

         lda ChangeScreenBuffor                          ;ktry ScreenBuffor ?
         eor #1
         tay
         LDA AddrCharsetsTABChange,Y
         add :YCoordinateOpponentTABH,X
         STA address5Opponent+1

         ldx ChangeScreenBuffor                          ;ktry ScreenBuffor ?
         lda YOldCoordinateOpponentTAB,x                 ;Oblicz adres startowy na ekranie dla wywietlenia przeciwnika
         sub #24
         tax
         mva :YCoordinateOpponentTABL,x address7Opponent
         lda AddrCharsetsTABChange,y                     ; UWAGA! zakadamy, e Y jest ju ustawione wczeniej
         add :YCoordinateOpponentTABH,x
         sta address7Opponent+1

         mva #2 IsClearLeftOutline                       ;=2 naley rysowa 2 puste znaki z lewej strony
         sta IsClearRightOutline

         lda XCoordinateOpponent
         sub #48+8                                       ;zacznij dwa znaki wczeniej - konieczne dla zamazywania poprzedniej klatki
         BCS _skp

         dec IsClearLeftOutline
         lda XCoordinateOpponent
         sub #48+4
         bcs _skp

         dec IsClearLeftOutline
         lda #0

_skp     AND #255-3
         asl @                  ;podzielone przez 4, nastepnie pomnoone przez 8
         add address5Opponent
         STA address5Opponent
         LDA address5Opponent+1
         ADC #0
         STA address5Opponent+1

         LDX ChangeScreenBuffor  ;ktry ScreenBuffor ?
         LDA XOldCoordinateOpponentTAB,X
         sub #48
         AND #255-3
         asl @      ;podzielone przez 4, nastepnie pomnoone przez 8
         TAX
         LDA address7Opponent+1
         ADC #0
         STA address7Opponent+1
         TXA
         add address7Opponent
         STA address7Opponent
         LDA address7Opponent+1
         ADC #0
         STA address7Opponent+1

         lda Opponent           ; Wyjtek dla CHAIN!
         cmp #Chain
         bne shw_dr1

         lda is_opponent_walk  ; czy stoi w miejscu?
         bne shw_dr1

         lda PORTAOpponent     ; czy wykonuje atak acuchem?
         cmp # 7+:FIRE
         beq shw_dr0
         cmp #11+:FIRE
         beq shw_dr0
         cmp #13+:FIRE
         bne shw_dr1

shw_dr0  mva #0 IsClearLeftOutline
         sta IsClearRightOutline

shw_dr1  lda IsClearLeftOutline     ;Czy mona rysowa z lewej strony znak zamazujcy?
         beq ShowOpponentA01b

         :3 asl @                           ;*8
         sta Data1Opponent
         sbw address4Opponent Data1Opponent ;odejmij 8-16(1-2 znaki) od address4Opponent bo z lewej strony bdzie rysowany znak zamazujcy

ShowOpponentA01b ; zapamitaj wyliczone adresy - wykorzystywane w ShowHITOpponent
 ;        mwa address5opponent Storeaddress5opponent

; kasowanie przeciwnika
         LDA IsThrowWeapon            ;Pomi dalsz cz, zostanie ona wykonana w ShowWeapon dopiero...
         BEQ ShowOpponentDraw
         RTS
.ENDP
;-----------------------------------
ShowOpponentDraw
         mva #0 IsDrawOpponent

         lda is_first_chain
         bne ShowOpponent00c_    ; kasuj cao ta jeeli pierwszy raz rzucono acuchem

         LDA IsClearOpponent     ;Czy drugi raz wykasowa star pozycj po odwrceniu si przeciwnika w przeciwn
         BNE ShowOpponent00c     ;stron?

         LDA IsOpponentFaceOnRight
         CMP StoreIsOpponentFaceOnRight
         jeq ShowOpponentDraw01

ShowOpponent00c_
         mva #2 IsClearOpponent

ShowOpponent00c
         dec IsClearOpponent

; zmazanie przeciwnika na starej pozycji
         lda #0
         sta is_first_chain
         tay
         :9*8-1 sta (address7Opponent),y+ ; wywietlenie pustego wiersza - 9znakw, eby zamaza ewentualne pozostaoci
                sta (address7Opponent),y
         adw address7Opponent #[320-9*8+1]

         lda #0
         :9*8-1 sta (address7Opponent),y+ ; wywietlenie pustego wiersza - 9znakw, eby zamaza ewentualne pozostaoci
                sta (address7Opponent),y
         adw address7Opponent #[320+64-9*8+1]

         lda #0
         :9*8-1 sta (address7Opponent),y+ ; wywietlenie pustego wiersza - 9znakw, eby zamaza ewentualne pozostaoci
                sta (address7Opponent),y
         adw address7Opponent #[320+2*9*8-2]

         lda #0
         tay
         :9*8-1 sta (address7Opponent),y+ ; wywietlenie pustego wiersza - 9znakw, eby zamaza ewentualne pozostaoci
                sta (address7Opponent),y
         adw address7Opponent #[320-9*8+1]

         lda #0
         :9*8-1 sta (address7Opponent),y+ ; wywietlenie pustego wiersza - 9znakw, eby zamaza ewentualne pozostaoci
                sta (address7Opponent),y
         adw address7Opponent #[320+64-9*8+1]

         lda #0
         :9*8-1 sta (address7Opponent),y+ ; wywietlenie pustego wiersza - 9znakw, eby zamaza ewentualne pozostaoci
                sta (address7Opponent),y

; wywietlenie przeciwnika na nowej pozycji
ShowOpponentDraw01
         mva PORTB save_PORTB

         ldx IsClearLeftOutline
         ldy OpponentBitmapBank
         mva BANKS+0,y PORTB

         ldy #0
         tya

         cpx #0
         beq shw_opp1
shw_lop1 :1*8   sta (address5Opponent),y+                      ; zma 1-2 znaki z lewej strony
         dex
         bne shw_lop1
         ldx IsClearLeftOutline

shw_opp1 :8*8   mva (address4Opponent),y (address5Opponent),y+ ; rysuj wiersz klatki z przeciwnikiem (9 znakw)

         lda IsClearRightOutline
         beq shw_opq1
         :1*8   mva (address4Opponent),y (address5Opponent),y+
         lda #0
         :2*8-1 sta (address5Opponent),y+                      ; zma 2 znaki z prawej strony
                sta (address5Opponent),y

shw_opq1 adw address4Opponent #9*8
         adw address5Opponent #320

         ldy #0
         tya

         cpx #0
         beq shw_opp2
shw_lop2 :1*8   sta (address5Opponent),y+                      ; zma 1-2 znaki z lewej strony
         dex
         bne shw_lop2
         ldx IsClearLeftOutline

shw_opp2 :8*8   mva (address4Opponent),y (address5Opponent),y+ ; rysuj wiersz klatki z przeciwnikiem (9 znakw)

         lda IsClearRightOutline
         beq shw_opq2
         :1*8   mva (address4Opponent),y (address5Opponent),y+
         lda #0
         :2*8-1 sta (address5Opponent),y+                      ; zma 2 znaki z prawej strony
                sta (address5Opponent),y

shw_opq2 adw address4Opponent #9*8
         adw address5Opponent #320+64

         ldy #0
         tya

         cpx #0
         beq shw_opp3
shw_lop3 :1*8   sta (address5Opponent),y+                      ; zma 1-2 znaki z lewej strony
         dex
         bne shw_lop3
         ldx IsClearLeftOutline

shw_opp3 :8*8   mva (address4Opponent),y (address5Opponent),y+ ; rysuj wiersz klatki z przeciwnikiem (9 znakw)

         lda IsClearRightOutline
         beq shw_opq3
         :1*8   mva (address4Opponent),y (address5Opponent),y+
         lda #0
         :2*8-1 sta (address5Opponent),y+                      ; zma 2 znaki z prawej strony
                sta (address5Opponent),y

shw_opq3 adw address4Opponent #9*8
         adw address5Opponent #320

         ldy #0
         tya

         cpx #0
         beq shw_opp4
shw_lop4 :1*8   sta (address5Opponent),y+                      ; zma 1-2 znaki z lewej strony
         dex
         bne shw_lop4
         ldx IsClearLeftOutline

shw_opp4 :8*8   mva (address4Opponent),y (address5Opponent),y+ ; rysuj wiersz klatki z przeciwnikiem (9 znakw)

         lda IsClearRightOutline
         beq shw_opq4
         :1*8   mva (address4Opponent),y (address5Opponent),y+
         lda #0
         :2*8-1 sta (address5Opponent),y+                      ; zma 2 znaki z prawej strony
                sta (address5Opponent),y

shw_opq4 adw address4Opponent #9*8
         adw address5Opponent #320

         ldy #0
         tya

         cpx #0
         beq shw_opp5
shw_lop5 :1*8   sta (address5Opponent),y+                      ; zma 1-2 znaki z lewej strony
         dex
         bne shw_lop5
         ldx IsClearLeftOutline

shw_opp5 :8*8   mva (address4Opponent),y (address5Opponent),y+ ; rysuj wiersz klatki z przeciwnikiem (9 znakw)

         lda IsClearRightOutline
         beq shw_opq5
         :1*8   mva (address4Opponent),y (address5Opponent),y+
         lda #0
         :2*8-1 sta (address5Opponent),y+                      ; zma 2 znaki z prawej strony
                sta (address5Opponent),y

shw_opq5 adw address4Opponent #9*8
         adw address5Opponent #320+64

         ldy #0
         tya

         cpx #0
         beq shw_opp6
shw_lop6 :1*8   sta (address5Opponent),y+                      ; zma 1-2 znaki z lewej strony
         dex
         bne shw_lop6
         ldx IsClearLeftOutline

shw_opp6 :8*8   mva (address4Opponent),y (address5Opponent),y+ ; rysuj wiersz klatki z przeciwnikiem (9 znakw)

         lda IsClearRightOutline
         beq shw_opq6
         :1*8   mva (address4Opponent),y (address5Opponent),y+
         lda #0
         :2*8-1 sta (address5Opponent),y+                      ; zma 2 znaki z prawej strony
                sta (address5Opponent),y

shw_opq6 mva save_PORTB PORTB

ShowOpponent09
         LDA Bar01             ; Sprawd czy przeciwnik jest ju zabity?
         BEQ ShowOpponent10    ; Tak, wic pomi 2 ponisze linijki poniewa ju nie moe zrobi krzywdy graczowi!

         jsr ShowHITOpponent
         jsr ShowHITWeapon
sh_hit2  jsr ShowOpponent12    ; czasami jsr ShowHITPlayer

ShowOpponent10
; wska na drugi buffor
         LDY ChangeScreenBuffor
         mva XCoordinateOpponent XOldCoordinateOpponent
         STA XOldCoordinateOpponentTAB,Y
         mva YCoordinateOpponent YOldCoordinateOpponent
         STA YOldCoordinateOpponentTAB,Y

         LDA IsThrowWeapon     ; Pomi dalsz cz, zostanie ona wykonana w ShowWeapon dopiero...
         BNE ShowOpponent11

         INY
         TYA
         AND #1
         STA ChangeScreenBuffor
         mva #1 IsSetOpponentVBL
         LDA Bar02
         jeq DeadPlayer     ; zabity Player!

ShowOpponent11
         mva IsOpponentFaceOnRight StoreIsOpponentFaceOnRight

ShowOpponent12
         RTS

IsClearOpponent  .byte 0 ;=1 naley dokona drugiego cakowitego kasowania przeciwnika na starej pozycji
                         ;po jego odwrceniu si w przeciwn stron
is_opponent_walk .byte 0 ;=1 to wanie wykonywana animacja chodzenia przeciwnika (dziki temu mona przypieszy rysowanie(ShowOpponent) bo rysujemy mniej znakw
XOldCoordinateOpponentTAB .BYTE 0,0
YOldCoordinateOpponentTAB .BYTE 0,0
;----------------------
; procedura rysujca przeciwnika, ale tylko dla ekranw z drzwiami!
; poza tym korzysta z danych 8 bajtw na 6 wierszy a nie 9 bajtw na 6 wierszy
PrimitiveShowOpponentDoor
         STX address4
         STY address4+1
         STA OpponentBitmapBank
         LDX #<Conv11to00And00to11
         LDY #>Conv11to00And00to11
         STX Convert+1
         STY Convert+2
         JMP PrimitiveShowOp01

PrimitiveShowOpponent ; Wywietla przeciwnika na pozycji X/YCoordinateOpponent
         STX address4
         STY address4+1
         STA OpponentBitmapBank
         LDX #<Conv11to00And00to01And01to11
         LDY #>Conv11to00And00to01And01to11
         STX Convert+1
         STY Convert+2

PrimitiveShowOp01
         LDA IsOpponentFaceOnRight
         BEQ PrimitiveShowOp02
         LDA address4
         CLC
         ADC #<$0182
         STA address4
         LDA address4+1
         ADC #>$0182
         STA address4+1

PrimitiveShowOp02
         LDA PORTB
         PHA

         LDA Banks+9
         STA PORTB

         LDA YCoordinateOpponent ;Oblicz adres startowy na ekranie dla wywietlenia przeciwnika
         SEC
         SBC #24
         TAX
         STA Data2
         lsr @  ;podziel przez 8
         lsr @
         lsr @
         STA Data5
         LDA :YCoordinateOpponentTABL,X
         STA address5Opponent
         LDY ChangeScreenBuffor  ;ktry ScreenBuffor ?
         INY
         TYA
         AND #1
         TAY
         LDA AddrCharsetsTABChange,Y
         CLC
         ADC :YCoordinateOpponentTABH,X
         STA address5Opponent+1

         LDA XCoordinateOpponent
         SEC
         SBC #48
         AND #255-3
         asl @      ;podzielone przez 4, nastepnie pomnoone przez 8
         CLC
         ADC address5Opponent
         STA address5Opponent
         LDA address5Opponent+1
         ADC #0
         STA address5Opponent+1

         LDA OpponentBitmapBank
         TAY
         LDA BANKS+0,Y
         STA PORTB

; wywietlenie przeciwnika
         LDA #6  ;ile wierszy wywietli
         STA Counter1Opponent

PrimitiveShowOpponent01
         LDX #8
         LDY #0

PrimitiveShowOpponent04
         JMP PrimitiveShowOpponentOrg

PrimitiveShowOpponent05
         DEX
         BNE PrimitiveShowOpponent04

PrimitiveShowOpponent07
         TYA
         CLC
         ADC address4
         STA address4
         LDA address4+1
         ADC #0
         STA address4+1

         LDA Data5
         TAX
         INC Data5

         LDA address5Opponent
         CLC
         ADC Add320OpponentTABL,X
         STA address5Opponent
         LDA address5Opponent+1
         ADC Add320OpponentTABH,X
         STA address5Opponent+1

         DEC Counter1Opponent
         BNE PrimitiveShowOpponent01

         PLA
         STA PORTB

         LDA IsAllowChangeBuffor
         SNE
         RTS
; wska na drugi buffor
NextScreenBuffor
         LDY ChangeScreenBuffor
         INY
         TYA
         AND #1
         STA ChangeScreenBuffor

         RTS

IsAllowChangeBuffor .BYTE 0 ; Czy wolno zmieni buffer?
;-------------------------------------------------------------
ConvA .BYTE 0
ConvX .BYTE 0

Bits01 .BYTE 0
Bits23 .BYTE 0
Bits45 .BYTE 0

Conv11to00And00to11
         STA ConvA
         STX ConvX

         AND #3
         TAX
         LDA ConvTAB11,X
         STA Bits01

         LDA ConvA
         :2 lsr @
         AND #3
         TAX
         LDA ConvTAB22,X
         STA Bits23

         LDA ConvA
         :4 lsr @
         AND #3
         TAX
         LDA ConvTAB33,X
         STA Bits45

         LDA ConvA
         :6 lsr @
         AND #3
         TAX
         LDA ConvTAB44,X
         CLC
         ADC Bits45
         ADC Bits23
         ADC Bits01

         LDX ConvX
         RTS

Conv11to00And00to01And01to11
         STA ConvA
         STX ConvX

         AND #3
         TAX
         LDA ConvTAB1,X
         STA Bits01

         LDA ConvA
         :2 lsr @
         AND #3
         TAX
         LDA ConvTAB2,X
         STA Bits23

         LDA ConvA
         :4 lsr @
         AND #3
         TAX
         LDA ConvTAB3,X
         STA Bits45

         LDA ConvA
         :6 lsr @
         AND #3
         TAX
         LDA ConvTAB4,X
         CLC
         ADC Bits45
         ADC Bits23
         ADC Bits01

         LDX ConvX
         RTS

ConvTAB1 .BYTE 1,3,2,0
ConvTAB2 .BYTE 1*4,3*4,2*4,0*4
ConvTAB3 .BYTE 1*16,3*16,2*16,0*16
ConvTAB4 .BYTE 1*64,3*64,2*64,0*64

ConvTAB11 .BYTE 3,1,2,0
ConvTAB22 .BYTE 3*4,1*4,2*4,0*4
ConvTAB33 .BYTE 3*16,1*16,2*16,0*16
ConvTAB44 .BYTE 3*64,1*64,2*64,0*64

Convert JMP Conv11to00And00to01And01to11

PrimitiveShowOpponentOrg
         LDA (address4),Y
         JSR Convert
         STA (address5Opponent),Y
         INY
         LDA (address4),Y
         JSR Convert
         STA (address5Opponent),Y
         INY
         LDA (address4),Y
         JSR Convert
         STA (address5Opponent),Y
         INY
         LDA (address4),Y
         JSR Convert
         STA (address5Opponent),Y
         INY
         LDA (address4),Y
         JSR Convert
         STA (address5Opponent),Y
         INY
         LDA (address4),Y
         JSR Convert
         STA (address5Opponent),Y
         INY
         LDA (address4),Y
         JSR Convert
         STA (address5Opponent),Y
         INY
         LDA (address4),Y
         JSR Convert
         STA (address5Opponent),Y
         INY
         JMP PrimitiveShowOpponent05
;-------------------------------------------------------------
ShowPlayer ; Wywietla gracza na pozycji X/YCoordinatePlayer
         stx :AddrPlayerBitmap
         sty :AddrPlayerBitmap+1
ShowPlayerLast
         mwa :AddrPlayerBitmap address4

         lda IsPlayerFaceOnRight
         bne ShowPl01

         adw address4 #size_frame_player
;dupa
                                                                               ; adres danych dla player'a 0
ShowPl01 LDX address4   \ stx ShowPlayer01+1  \ stx ShowPlayer05+1
         LDY address4+1 \ sty ShowPlayer01+2  \ sty ShowPlayer05+2

         TXA \ add #1*48 \ STA ShowPlayer01+7  \ sta ShowPlayer05+7  \ TYA \ ADC #0 \ STA ShowPlayer01+8  \ sta ShowPlayer05+8  ; obl. adres danych dla player'a 1
         TXA \ add #2*48 \ STA ShowPlayer01+13 \ sta ShowPlayer05+13 \ TYA \ ADC #0 \ STA ShowPlayer01+14 \ sta ShowPlayer05+14 ; obl. adres danych dla player'a 2
         TXA \ add #3*48 \ STA ShowPlayer01+19 \ sta ShowPlayer05+19 \ TYA \ ADC #0 \ STA ShowPlayer01+20 \ sta ShowPlayer05+20 ; obl. adres danych dla player'a 3
         TXA \ add #4*48 \ STA ShowPlayer01+25 \ sta ShowPlayer05+25 \ TYA \ ADC #0 \ STA ShowPlayer01+26 \ sta ShowPlayer05+26 ; obl. adres danych dla pociskw

         mva PORTB   save_PORTB
         mva Banks+2 PORTB

         LDA ChangeAddrPMBASE
         BEQ ShowPlayer03

         lda YCoordinatePlayer    ; przygotuj dane dla wikszego speedu ptli!
         sta ShowPlayer01+4
         sta ShowPlayer01+10
         sta ShowPlayer01+16
         sta ShowPlayer01+22
         sta ShowPlayer01+28

         ldy #47
ShowPlayer01
         mva $FFFF,y $DC00,y
         mva $FFFF,y $DD00,y
         mva $FFFF,y $DE00,y
         mva $FFFF,y $DF00,y
         mva $FFFF,y $DB00,y
         dey
         bpl ShowPlayer01

ShowPlayer02
         mva save_PORTB PORTB

         LDA Bar02	;Sprawd czy Player martwy?
         SEQ		;TAK, wic nie moe ju wyprowadzi ciosu!
         JSR ShowHITPlayer

         mva #1 IsSetPlayerVBL  ;ju wolno wykonywa t procedur podczas przerwania
         RTS

ShowPlayer03
         lda YCoordinatePlayer    ; przygotuj dane dla wikszego speedu ptli!
         sta ShowPlayer05+4
         sta ShowPlayer05+10
         sta ShowPlayer05+16
         sta ShowPlayer05+22
         sta ShowPlayer05+28

         ldy #47
ShowPlayer05
         mva $FFFF,y $E400,y
         mva $FFFF,y $E500,y
         mva $FFFF,y $E600,y
         mva $FFFF,y $E700,y
         mva $FFFF,y $E300,y
         dey
         bpl ShowPlayer05
         bmi ShowPlayer02 ;JMP
;--------------------------
StorePMBASE .byte 0

ShowPlayerContinueVBL
         lda ChangeAddrPMBASE
         eor #1
         sta ChangeAddrPMBASE
         tax
         mva PMBASETAB1,X PMBASE
         sta StorePMBASE

         JSR SetPositionPlayer

         ; naley teraz wyczyci gracza na starym miejscu
         LDX ChangeAddrPMBASE
         BNE ShowPlayerDC00
         BEQ ShowPlayerE400 ;JMP (!)
;-----------------------------------------
ShowPlayerDC00
         lda YOldCoordinatePlayer,x
         BEQ ShowPlayerRTS

         sub #5
         sta ShowPlayer00+1       ; przygotuj dane dla wikszego speedu ptli!
         sta ShowPlayer00+4
         sta ShowPlayer00+7
         sta ShowPlayer00+10
         sta ShowPlayer00+13

         LDA #$00
         LDY #48+1+4-1
ShowPlayer00             ;czy gracza na starym miejscu
         STA $DC00,y
         STA $DD00,y
         STA $DE00,y
         STA $DF00,y
         STA $DB00,y
         dey
         bpl ShowPlayer00

ShowPlayerRTS
         ldy ChangeAddrPMBASE
         mva YCoordinatePlayer YOldCoordinatePlayer,y
         mva XCoordinatePlayer XOldCoordinatePlayer,y
         RTS

IsSetPlayerVBL   .byte 0 ;czy wolno wykonywa t procedur podczas przerwania? 1=TAK
IsSetOpponentVBL .byte 0 ;czy wolno wykonywa t procedur podczas przerwania? 1=TAK
;-----------------------------------------
ShowPlayerE400
         lda YOldCoordinatePlayer,x
         BEQ ShowPlayerRTS

         sub #5
         sta ShowPlayer04+1       ; przygotuj dane dla wikszego speedu ptli!
         sta ShowPlayer04+4
         sta ShowPlayer04+7
         sta ShowPlayer04+10
         sta ShowPlayer04+13

         LDA #$00
         LDY #48+1+4-1
ShowPlayer04             ;czy gracza na starym miejscu
         STA $E400,y
         STA $E500,y
         STA $E600,y
         STA $E700,y
         STA $E300,y
         dey
         bpl ShowPlayer04
         bmi ShowPlayerRTS ;JMP (!)
;-----------------------------------------------------
WaitLineAndSetPositionPlayer
         LDA #24+64/2
         CMP VCOUNT
         RCS
SetPositionPlayer
         LDA IsPlayerFaceOnRight
         :2 asl @
         tax
         LDA XCoordinatePlayer
         add XCoordinatePlayerTAB,X
         STA StoreHPOSP0
         STA StoreHPOSP1
         INX
         ADC XCoordinatePlayerTAB,X
         STA StoreHPOSP2
         STA StoreHPOSP3
         inx
         adc XCoordinatePlayerTAB,x
         sta StoreHPOSM2
         sta StoreHPOSM3
         inx
         adc XCoordinatePlayerTAB,x
         sta StoreHPOSM0
         sta StoreHPOSM1
         rts
;--------------------------
; tutaj s pozycje graczy i pociskw PM/G
StoreHPOSP0 .BYTE 0
StoreHPOSP1 .BYTE 0
StoreHPOSP2 .BYTE 0
StoreHPOSP3 .BYTE 0
StoreHPOSM0 .BYTE 0
StoreHPOSM1 .BYTE 0
StoreHPOSM2 .BYTE 0
StoreHPOSM3 .BYTE 0
StoreSIZEM  .BYTE 0
HighUpper   = 0
HighUpperD  = 6
HighMiddleU = 12
HighMiddleD = 18
HighDown    = 32
HighDownD   = 38
HighHIT .byte HighDown        ; pozycja uderzenia
CounterHIT       .byte 0      ; licznik jak dugo wywietla lad uderzenia?
ScorePlayer      .word 0      ; w kodzie BCD
ScorePlayerLast  .word 0      ; w kodzie BCD
ScorePlayer1     .word 0      ; w kodzie BCD - t komrk i niej nie wolno rozdzieli!
ScorePlayer2     .word 0      ; w kodzie BCD
ScorePlayer1Last .word 0      ; w kodzie BCD
ScorePlayer2Last .word 0      ; w kodzie BCD
HiScorePlayer    .word $0090  ; w kodzie BCD
OneTwoPlayer     .byte 0      ; 1 - gra na jednego gracza, 2-gra na dwch graczy

HighHITO    .byte HighDown    ; pozycja uderzenia
HighHITW    .byte HighDown    ; pozycja uderzenia

IsChainReturn .byte 0         ; =1 kiedy acuch wraca dziki temu nie jest on ju grony dla gracza!

CounterHITO .byte 0           ; licznik jak dugo wywietla lad uderzenia?
CounterHITW .byte 0           ; licznik jak dugo wywietla lad uderzenia?

ThrowBackPlayer       .byte 0 ;odrzu playera od przeciwnika np: po trafieniu z wyskoku przeciwnika
;Storeaddress5opponent .word 0
;----------------------------------------------------
ShowHITPlayer
         LDA PORTB
         PHA
         LDA BANKS+9
         STA PORTB
         JSR :ShowHITPlayerBank
         PLA
         STA PORTB
         RTS
;-----------------------------------------------------
ShowHITWeapon
         LDA PORTB
         PHA
         LDA BANKS+9
         STA PORTB
         JSR :ShowHITWeaponBank
         PLA
         STA PORTB
         RTS
;----------------------------------------------------
ShowHITOpponent
         LDA PORTB
         PHA
         LDA BANKS+9
         STA PORTB
         JSR :ShowHITOpponentBank
         PLA
         STA PORTB
         RTS
;----------------------------------------------------
PMBASETAB1             .byte $D8,$E0
XCoordinatePlayerTAB
 .byte 12,-8,-3,-3
 .byte 0,8,8,2
XOldCoordinatePlayer   .byte 0,0           ; pmbase 1/2
YOldCoordinatePlayer   .byte 0,0           ; pmbase 1/2
IsPlayerFaceOnRight    .byte 1 ;1 - YES

XOldCoordinateWeaponTAB
 .BYTE 0,0
YOldCoordinateWeaponTAB
 .BYTE 0,0

address4BufforWeaponTABL
 .BYTE <:WeaponBuff1,<:WeaponBuff2
address4BufforWeaponTABH
 .BYTE >:WeaponBuff1,>:WeaponBuff2

IsEnd                       .byte 0 ; 1 - kocz!  ControlBehaviorPlayerAndOpponentBank
IsWeaponFaceOnRight         .byte 0 ; 0 - NO
StoreIsWeaponFaceOnRight    .byte 0 ; 0 - NO
Counter1Weapon              .byte 0
IndexIsWeaponFaceOnRight    .byte 0
IsSetWeaponVBL              .byte 0
AddrPlayerBitmap            .word :PlayerBitmapRight1
Weapon                      .byte 0
WeaponColor                 .byte 0
WeaponColorTAB              .byte 1*16+8,1*16+4,8*16+6
XOldCoordinateWeapon        .byte 0
YOldCoordinateWeapon        .byte 0
IsFirstCallWeapon           .byte 1 ; Czy pierwszy raz wywoano procedur?
IsChainWeapon               .byte 0 ; =1 nie jest odtwarzane to dla Weapon!
CounterWeapon               .byte 0 ; ile razy animowa bro na podstaiwie biecych parametrw

PlayerBitmapBank            .byte 2
CounterPlayer               .byte 0 ; ile razy animowa PLAYER'a na podstaiwie biecych parametrw
CounterOpponent             .byte 0 ; ile razy animowa Opponenta na podstaiwie biecych parametrw
IsFirstCall                 .byte 1 ; Czy pierwszy raz wywoano procedur?
IsFirstCallOpponent         .byte 1 ; Czy pierwszy raz wywoano procedur?
is_first_chain              .byte 0 ;=1 pierwsze wywoanie rysowania acucha
CounterBlinkValue           = 25
IsBreakAnimOpponent         .byte 0 ; Czy wolno przerwa animacj Przeciwnika?

SwitchONOpponentBehavior    .byte 0
MaxSwitchONOpponentBehavior .byte 0
IndexOpponentString         .byte 0
ActionOpponentString        .byte 0,0,0,0,0,0,0,0
LastHitOpponent             .byte 0
IsOpponentEscape            .byte 0
LastActionOpponent          .byte 0 ; jaki ostatnio przeciwnik wykona cios lub ruch?
PORTAOpponent               .BYTE 0 ; to samo, ale w innej postaci
IsVibratePlayer             .byte 0
WhichRangeOpponent          .byte 0
RepeatBehavior              .byte 0
MemIsOpponentFaceOnRight    .byte 0
LastAction                  .byte 0
IsActionContinue            .byte 0
ActionContinue              .byte 0
StoreChangeScreenBuffor     .byte 0 ; uywane jedynie przez ControlBehaviorWeapon dla zamazania acucha do koca
IsVBLDid                    .byte 0 ; zerowane po wykonaniu przerwania VBL
IsPlayerHited               .byte 0 ; =1 gracz zosta trafiony wanie przez przeciwnika
IsOpponentHited             .byte 0 ; =1 przeciwnik zosta trafiony wanie przez gracza
IsPlayerAttack              .byte 0 ; =1 aktualna klatka ciosu gracza jest klatk, ktra moe trafi przeciwnika

ControlBehaviorPlayerAndOpponent
         LDA PORTB
         PHA
         LDA Banks+9
         STA PORTB
         JSR :ControlBehaviorPlayerAndOpponentBank
         PLA
         STA PORTB
         RTS
;------------------------------------------------------------
;XA=NumberA*NumberB+XA
MUL	.PROC

	ldy NumberB
	beq don      ;skok gdy NumberB=0
	clc
lop	adc NumberA  ;dodanie NumberA
	bcc _SKP
	inx          ;zwikszenie MSB wyniku
	clc
_SKP	dey          ;zmniejszenie NumberB o 1
	bne lop      ;skok gdy NumberB<>0
don	rts

	.ENDP

NumberA  .byte 0
NumberB  .byte 0
;-----------------------------------------------------------
RefreshLifePlayer
        @BANK_JSR :RefreshLifePlayerBank
        rts
ZeroWeaponBuff
        @BANK_JSR :ZeroWeaponBuffBank
        rts

 .print
 .print 'Used memory: $0c00-',*
 .print

 run RunGame
