;************************************
; Generowanie SFX-w na przerw. VBL
;************************************

VVBLKD   =   $0224
RANDOM   =   $D20A
COLBK    =   $D01A
NMIEN    =   $D40E
AUDF4    =   $D206
AUDC4    =   $D207
AUDCTL   =   $D208

; zpage
adr_sfx  =   $80       ; adres aktualnie odgrywanego SFX
cnt_sfx  =   adr_sfx+2 ; pozycja aktualnie odgrywana w SFX
ind_sts  =   adr_sfx+3 ; wskanik stosu (dla zagniedzonych ptli w SFX)

  org $8000

; adresy skokw - musz by od pocztku strony!
tab_skp
  jmp ply_snd
  jmp jmp_snd
  jmp chg_frq
  jmp chg_vol
  jmp vbl_sfx3
  jmp rep_snd
  jmp nxt_snd
  jmp auf_snd
  jmp auc_snd
  jmp ctl_snd

; graj jeden dwik
ply_snd
     iny
     lda (adr_sfx),y
     sta audf4s
     sta audf4
     iny
     lda (adr_sfx),y
     sta audc4s
     sta audc4
     iny
     sty cnt_sfx
     jmp vbl_sfx3

; skocz do podanej pozycji
jmp_snd
     iny
     lda (adr_sfx),y
     sta cnt_sfx
     jmp vbl_sfx3

; zwiksz/zmniejsz czstotliwo
chg_frq
     lda audf4s
     iny
     add (adr_sfx),y
     iny
     sta audf4s
     sta audf4
     sty cnt_sfx
     jmp vbl_sfx3

; zwiksz/zmniejsz gono
chg_vol
     lda audc4s
     and #%11110000
     sta chg_vol2+1
     lda audc4s
     iny
     add (adr_sfx),y
     iny
     and #%00001111
chg_vol2
     ora #$FF
     sta audc4
     sta audc4s
     sty cnt_sfx
     jmp vbl_sfx3

; wykonaj ptle 'x' razy (x=1..255)
rep_snd
     iny
     lda (adr_sfx),y
     ldx ind_sts
     sta sfx_st1,x       ; zapamitaj ile razy
     iny
     sty cnt_sfx
     tya
     sta sfx_st2,x       ; zapamitaj, od ktrej pozycji
     inc ind_sts
     jmp vbl_sfx1

; skocz do pocztku ptli
nxt_snd
     ldx ind_sts
     dec sfx_st1-1,x
     bne nxt_snd2
     inc cnt_sfx
     dec ind_sts
     jmp vbl_sfx3

nxt_snd2
     lda sfx_st2-1,x
     sta cnt_sfx
     jmp vbl_sfx3

; ustaw AUDF4
auf_snd
     iny
     lda (adr_sfx),y
     sta audf4s
     sta audf4
     iny
     sty cnt_sfx
     jmp vbl_sfx3

; ustaw AUDC4
auc_snd
     iny
     lda (adr_sfx),y
     sta audc4s
     sta audc4
     iny
     sty cnt_sfx
     jmp vbl_sfx3

; ustaw AUDCTL
ctl_snd
     iny
     lda (adr_sfx),y
     sta audc4s
     sta audc4
     iny
     sty cnt_sfx
     jmp vbl_sfx3

; pocztek programu
Start
     ldx #<SFX1
     ldy #>SFX1
     jsr PlaySFX

     mva 764 $FF
     cmp 764
     beq *-3

loopst
     lda random
     sta colbk
     jmp loopst
;------------------------
PlaySFX
     stx adr_sfx
     sty adr_sfx+1
     mva #0 cnt_sfx
     sta ind_sts         ;stos na zero
     lda nmien
     and #64
     sta nmien
     mwa #vbl_sfx1 vvblkd
     lda nmien
     ora #64
     sta nmien
     rts
;------------------------
vbl_sfx1
     ldy cnt_sfx
     lda (adr_sfx),y
     bmi vbl_sfx2
     sta *+4
     jmp tab_skp

vbl_sfx2
     mwa #$E462 vvblkd

vbl_sfx3
     lda audf4s
     sta colbk
     pla
     tay
     pla
     tax
     pla
     rti

;------------------------
sfx_st1 :8 .byte 0 ; stos dla zagniedzonych ptli (sfx_for)
sfx_st2 :8 .byte 0 ; stos dla zagniedzonych ptli (sfx_nxt)
AUDF4s     .byte 0 ; rej. cie AUDF4
AUDC4s     .byte 0 ; rej. cie AUDC4
AUDCTLs    .byte 0 ; rej. cie AUDCTL

; wartoci rejestrw przesuwajcych 4-,5- i 17-bitowy (szumy)
noise.5.17 = 0
noise.5    = 32
noise.5.4  = 64
noise.17   = 128
noise.4    = 192

sfx_play = 0  ; graj dwik
sfx_jmp  = 3  ; skocz do podanej pozycji
sfx_chgf = 6  ; zwiksz/zmniejsz czstotliwo
sfx_chgv = 9  ; zwiksz/zmniejsz gono
sfx_nop  = 12 ; nic nie rb
sfx_for  = 15 ; wykonaj ptle 'x' razy (x=1..255)
sfx_nxt  = 18 ; skocz do pocztku ptli
sfx_audf = 21 ; ustaw AUDF4
sfx_audc = 24 ; ustaw AUDC4
sfx_auct = 27 ; ustaw AUDCTL

SFX1
 .byte sfx_play,0,noise.17+%0000

 .byte sfx_for,1
   .byte sfx_for,255
     .byte sfx_chgf,+1
     .byte sfx_for,15,sfx_chgv,+1,sfx_nxt
     .byte sfx_for,15,sfx_chgv,-1,sfx_nxt
   .byte sfx_nxt

 .byte sfx_nxt
 .byte -1

 run Start

